package com.randomsoftware.dance;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Keys
{
   static final int KEY_MENU   = 0x0001;
   static final int KEY_JUMP   = 0x0002;
   static final int KEY_LINDEX = 0x0004;
   static final int KEY_UP     = 0x0010;
   static final int KEY_DOWN   = 0x0020;
   static final int KEY_LEFT   = 0x0040;
   static final int KEY_RIGHT  = 0x0080;
   static final int KEY_CANCEL = 0x0100;
   static final int KEY_BACK   = 0x0200;
   static final int KEY_RINDEX = 0x0400;
   static final int KEY_HOOK   = 0x1000;
   static final int KEY_SEND   = 0x2000;

   static int translateKey (int rawKey)
   {
      switch (rawKey)
      {
         case Event.DEVICE_BUTTON_MENU:
            return KEY_MENU;
         case Event.DEVICE_BUTTON_JUMP:
            return KEY_JUMP;
         case Event.DEVICE_BUTTON_LEFT_SHOULDER:
            return KEY_LINDEX;
         case Event.DEVICE_ARROW_UP:
            return KEY_UP;
         case Event.DEVICE_ARROW_DOWN:
            return KEY_DOWN;
         case Event.DEVICE_ARROW_LEFT:
            return KEY_LEFT;
         case Event.DEVICE_ARROW_RIGHT:
            return KEY_RIGHT;
         case Event.DEVICE_BUTTON_CANCEL:
            return KEY_CANCEL;
         case Event.DEVICE_BUTTON_BACK:
            return KEY_BACK;
         case Event.DEVICE_BUTTON_RIGHT_SHOULDER:
            return KEY_RINDEX;
         case Event.DEVICE_BUTTON_END:
            return KEY_HOOK;
         case Event.DEVICE_BUTTON_SEND:
            return KEY_SEND;

         default:
            return 0;
      }
   }
}

