package com.randomsoftware.dance;
import com.randomsoftware.common.animation.*;
import com.randomsoftware.common.resloader.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class MainWindow extends AnimWindow
{
   public MainWindow (InputListener input)
   {
      super (input, AnimWindow.LARGE_WINDOW);
      setFullCoverage (true);
      _rm = null;
      _display = null;
   }

   public void show()
   {
      if (shouldUseResumeShow())
         _rm = new ResourceManager (new ResLoaderResumeShow());
      else
         _rm = new ResourceManager (new ResLoaderFullLogo (Resources.IDSND_LOGO));
      super.show();
   }

   public void hide()
   {
      if (_display != null)
      {
         _display.destroy();
         _display = null;
      }
      _rm.destroy();
      _rm = null;
      super.hide();
   }

   public ResourceManager resmgr()
   {
      return _rm;
   }

   public void paintBackground (Pen pp)
   {
      if (_rm.ready() && (_display != null))
      {
         _display.paint(pp);
      }
   }

   public void update()
   {
      if (_rm.ready())
      {
         if (_display == null)
         {
            _display = new Display();
         }
         _display.update();
      }
   }

   boolean shouldUseResumeShow()
   {
      boolean useResumeShow = false;
      long currentTime = System.currentTimeMillis();

      if (currentTime < _lastStartTime + CMSEC_FULL_LOGO_RENDER_TIME)
      {
         useResumeShow = true;
      }
      else if (Dance.game() != null)
      {
         useResumeShow = true;
      }

      _lastStartTime = currentTime;
      return useResumeShow;
   }

   ResourceManager _rm;
   Display _display;
   long _lastStartTime = 0;
   static final int CMSEC_FULL_LOGO_RENDER_TIME = 1000 * 60 * 15;
}

