package com.randomsoftware.dance;
import com.randomsoftware.common.animation.*;
import com.randomsoftware.common.resloader.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class ResourceManager extends ResLoader
{
   public ResourceManager (ResLoaderShow show)
   {
      super (Dance.window(), show);

      rKeyMenu = new Rect[2];
      rKeyMenu[0] = new Rect(0, 0, Config.KEY_ICON_SIZE, Config.KEY_ICON_SIZE);
      rKeyMenu[1] = new Rect(rKeyMenu[0]);  rKeyMenu[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyJump = new Rect[2];
      rKeyJump[0] = new Rect(rKeyMenu[0]);  rKeyJump[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyJump[1] = new Rect(rKeyJump[0]);  rKeyJump[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyCancel = new Rect[2];
      rKeyCancel[0] = new Rect(rKeyJump[0]);    rKeyCancel[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyCancel[1] = new Rect(rKeyCancel[0]);  rKeyCancel[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyBack = new Rect[2];
      rKeyBack[0] = new Rect(rKeyCancel[0]);  rKeyBack[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyBack[1] = new Rect(rKeyBack[0]);    rKeyBack[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyUp = new Rect[2];
      rKeyUp[0] = new Rect(rKeyBack[0]);  rKeyUp[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyUp[1] = new Rect(rKeyUp[0]);    rKeyUp[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyRight = new Rect[2];
      rKeyRight[0] = new Rect(rKeyUp[0]);     rKeyRight[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyRight[1] = new Rect(rKeyRight[0]);  rKeyRight[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyDown = new Rect[2];
      rKeyDown[0] = new Rect(rKeyRight[0]);  rKeyDown[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyDown[1] = new Rect(rKeyDown[0]);   rKeyDown[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyLeft = new Rect[2];
      rKeyLeft[0] = new Rect(rKeyDown[0]);  rKeyLeft[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyLeft[1] = new Rect(rKeyLeft[0]);  rKeyLeft[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyLindex = new Rect[2];
      rKeyLindex[0] = new Rect(rKeyLeft[0]);    rKeyLindex[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyLindex[1] = new Rect(rKeyLindex[0]);  rKeyLindex[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyRindex = new Rect[2];
      rKeyRindex[0] = new Rect(rKeyLindex[0]);  rKeyRindex[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyRindex[1] = new Rect(rKeyRindex[0]);  rKeyRindex[1].inset(0, Config.KEY_ICON_SIZE);

      rKeyHook = new Rect[2];
      rKeyHook[0] = new Rect(rKeyRindex[0]);  rKeyHook[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeyHook[1] = new Rect(rKeyHook[0]);    rKeyHook[1].inset(0, Config.KEY_ICON_SIZE);

      rKeySend = new Rect[2];
      rKeySend[0] = new Rect(rKeyHook[0]);  rKeySend[0].inset(Config.KEY_ICON_SIZE, 0);
      rKeySend[1] = new Rect(rKeySend[0]);  rKeySend[1].inset(0, Config.KEY_ICON_SIZE);
   }

   public void load()
   {
      ResUtil ru = Dance.resutil();
      bmpBackground = ru.getOpaqueBitmap (Resources.IDB_BACKGROUND);
      bmpKeys = ru.getOpaqueBitmap (Resources.IDB_KEYS);
   }

   public void unload()
   {
      bmpBackground = null;
      bmpKeys = null;
   }

   public Rect getKeyIconRect(int key, boolean hot)
   {
      switch (key)
      {
         case Keys.KEY_MENU:    return rKeyMenu[ hot ? 1 : 0 ];
         case Keys.KEY_JUMP:    return rKeyJump[ hot ? 1 : 0 ];
         case Keys.KEY_LINDEX:  return rKeyLindex[ hot ? 1 : 0 ];
         case Keys.KEY_UP:      return rKeyUp[ hot ? 1 : 0 ];
         case Keys.KEY_DOWN:    return rKeyDown[ hot ? 1 : 0 ];
         case Keys.KEY_LEFT:    return rKeyLeft[ hot ? 1 : 0 ];
         case Keys.KEY_RIGHT:   return rKeyRight[ hot ? 1 : 0 ];
         case Keys.KEY_CANCEL:  return rKeyCancel[ hot ? 1 : 0 ];
         case Keys.KEY_BACK:    return rKeyBack[ hot ? 1 : 0 ];
         case Keys.KEY_RINDEX:  return rKeyRindex[ hot ? 1 : 0 ];
         case Keys.KEY_HOOK:    return rKeyHook[ hot ? 1 : 0 ];
         case Keys.KEY_SEND:    return rKeySend[ hot ? 1 : 0 ];
         default:               return null;
      }
   }

   Bitmap bmpBackground;
   Bitmap bmpKeys;
   Rect[] rKeyMenu;
   Rect[] rKeyJump;
   Rect[] rKeyLindex;
   Rect[] rKeyUp;
   Rect[] rKeyDown;
   Rect[] rKeyLeft;
   Rect[] rKeyRight;
   Rect[] rKeyCancel;
   Rect[] rKeyBack;
   Rect[] rKeyRindex;
   Rect[] rKeyHook;
   Rect[] rKeySend;
}

