package com.randomsoftware.dance;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Song
{
   Song (String ss)
   {
      // Initialize the keys array to all zeroes

      keys = new int[ ss.length() ];
      for (int ii = 0; ii < ss.length(); ++ii)
      {
         keys[ii] = 0;
      }

      // Start reading the keys out of the string.  Combinations
      // just abut; each space advances to the next sequence.

      length = 0;

      for (int ii = 0; ii < ss.length(); ++ii)
      {
         switch(ss.charAt(ii))
         {
            case 'm':   keys[length] |= Keys.KEY_MENU;    break;
            case 'j':   keys[length] |= Keys.KEY_JUMP;    break;
            case '(':   keys[length] |= Keys.KEY_LINDEX;  break;
            case 'u':   keys[length] |= Keys.KEY_UP;      break;
            case 'd':   keys[length] |= Keys.KEY_DOWN;    break;
            case 'l':   keys[length] |= Keys.KEY_LEFT;    break;
            case 'r':   keys[length] |= Keys.KEY_RIGHT;   break;
            case 'c':   keys[length] |= Keys.KEY_CANCEL;  break;
            case 'b':   keys[length] |= Keys.KEY_BACK;    break;
            case ')':   keys[length] |= Keys.KEY_RINDEX;  break;
            case 'h':   keys[length] |= Keys.KEY_HOOK;    break;
            case 's':   keys[length] |= Keys.KEY_SEND;    break;
            default:    length++;  break;
         }
      }

      // If the string didn't end with a space, ensure the
      // last sequence is included in the song too.

      if (keys[length] != 0)
         ++length;
   }

   int keys[];
   int length;
}

