package com.randomsoftware.template;
import com.randomsoftware.common.animation.*;
import com.randomsoftware.common.resloader.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Template extends Application
{
   public Template()
   {
      _this = this;
      _settings = new Settings (this);
      _ru = new ResUtil (getResources());

      _splash = getResources().getSplashScreen(AppResources.ID_SPLASH_SCREEN_RESOURCE);
      updatePreviewScreen();

      _controller = new Controller();

      _window = new MainWindow(_controller);
      _window.setTitle (_ru.getString (Resources.IDS_TITLE));
      _window.setIcon (_ru.getTransparentBitmap (AppResources.ID_SMALL_ICON));
      _window.startTimer();
   }

   public void renderSplashScreen (View vv, Pen pp)
   {
      _splash.paint (vv, pp);
   }

   public void resume()
   {
      if (!_window.isVisible())
      {
         _controller.resume();
         _window.show();
      }
   }

   public void suspend()
   {
      if (_window.isVisible())
      {
         _controller.suspend();
         _window.hide();
      }
   }

   public static Template app()
   {
      return _this;
   }

   public static ResUtil resutil()
   {
      return app()._ru;
   }

   public static ResourceManager resmgr()
   {
      return window().resmgr();
   }

   public static MainWindow window()
   {
      return app()._window;
   }

   public static Settings settings()
   {
      return app()._settings;
   }

   public boolean receiveEvent (Event e)
   {
      switch (e.type)
      {
         case Event.EVENT_DATASTORE_RESTORED:
            _settings.reload();
            break;
      }

      return super.receiveEvent(e);
   }

   static Template _this;
   Settings _settings;
   ResUtil _ru;
   MainWindow _window;
   SplashScreen _splash;
   Controller _controller;
}

