package com.randomsoftware.threed;
import com.randomsoftware.common.animation.*;
import com.randomsoftware.common.resloader.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class MainWindow extends AnimWindow
{
   public MainWindow (InputListener input)
   {
      super (input, AnimWindow.LARGE_WINDOW);
      setFullCoverage (true);
      _rm = null;
      _test = null;
   }

   public void show()
   {
      _rm = new ResourceManager();
      super.show();
   }

   public void hide()
   {
      if (_test != null)
         _test.destroy();
      _test = null;

      _rm.destroy();
      _rm = null;
      super.hide();
   }

   public ResourceManager resmgr()
   {
      return _rm;
   }

   public void paintBackground (Pen pp)
   {
      pp.setColor (new Color (128, 128, 128));
      pp.fillRect (0, 0, 240, 160);
   }

   public void update()
   {
      if ((_rm != null) && (_rm.ready()) && (_test == null))
      {
         _test = new Test();
      }
      else if (_test != null)
      {
         _test.update();
      }
   }

   ResourceManager _rm;
   Test _test;
}

