package com.randomsoftware.triad;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Triad extends Application implements InputListener
{
   public Triad()
   {
      _this = this;
      _ru = new ResUtil (getResources());

      _splash = getResources().getSplashScreen(AppResources.ID_SPLASH_SCREEN_RESOURCE);
      updatePreviewScreen();

      _window = new AnimWindow (this, AnimWindow.SMALL_WINDOW);
      _window.setTitle (_ru.getString (Resources.IDS_TITLE));
      _window.setIcon (_ru.getTransparentBitmap (AppResources.ID_SMALL_ICON));
   }

   public void renderSplashScreen (View vv, Pen pp)
   {
      _splash.paint (vv, pp);
   }


   public float blindFill (Bitmap bmp, long cmsecStop)
   {
      long msecStart = System.currentTimeMillis();
      long count = 0;

      Pen pen = bmp.createPen();
      int width = bmp.getWidth();
      int height = bmp.getHeight();

      int xx[] = new int[4];
      int yy[] = new int[4];
      xx[0] = 0; yy[0] = 0;
      xx[1] = width; yy[1] = 0;
      xx[2] = width; yy[2] = height;
      xx[3] = 0; yy[3] = height;

      while (System.currentTimeMillis() < msecStart + cmsecStop)
      {
         for (int ii = 0; ii < 10; ++ii)
         {
            pen.drawPoly (xx, yy);
            ++count;
         }
      }

      long msecStop = System.currentTimeMillis();
      return (float)count * 1000 / (msecStop - msecStart);
   }


   public void quickTest()
   {
      DEBUG.p("STARTING QUICK TEST");

      Bitmap bmp = new Bitmap(240,160);
      long cmsecTest = 3000;

      DEBUG.p("blindFill: "+blindFill(bmp,cmsecTest)+" ops/sec");

      DEBUG.p("END QUICK TEST");
   }


   public void resume()
   {
      if (!_window.isVisible())
      {
         _window.show();
         quickTest();
      }
   }

   public void suspend()
   {
      if (_window.isVisible())
      {
         _window.hide();
      }
   }

   public static Triad app()
   {
      return _this;
   }

   public static AnimWindow window()
   {
      return app()._window;
   }

   public boolean receiveEvent (Event e)
   {
      return super.receiveEvent(e);
   }

   public boolean eventKeyDown (char c, Event e) { return false; }
   public boolean eventKeyUp (char c, Event e) { return false; }
   public boolean eventKeyRepeat (char c, Event e) { return false; }
   public boolean eventWidgetDown (int c, Event e) { return false; }
   public boolean eventWidgetUp (int c, Event e) { return false; }
   public boolean eventWidgetHeld (int c, Event e) { return false; }

   static Triad _this;
   ResUtil _ru;
   AnimWindow _window;
   SplashScreen _splash;
}

