package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class BaseMenuSprite extends AnimSprite
{
   public BaseMenuSprite()
   {
      super (Xaiden.window(), Layout.DEPTH_TITLE);
      _bmp = Xaiden.res().getTransparentBitmap (Resources.IDB_BASE_1);

      _celSize = _bmp.getHeight() / 4;
      _celxCount = _bmp.getWidth() / _celSize;
      _celyCount = _bmp.getHeight() / _celSize;
      _celCount = _celxCount * _celyCount;
      _celIndex = 0;
      _cel = new Rect();
      _cel.left = _cel.top = 0;
      _cel.right = _cel.bottom = _celSize;

      Rect rr = new Rect();
      rr.left = 12;
      rr.right = rr.left + _celSize;
      rr.bottom = Layout.HEIGHT_SCREEN - 30;
      rr.top = rr.bottom - _celSize;
      setRect(rr);
   }

   public void update()
   {
      _celIndex = (_celIndex+1) % _celCount;
      _cel.left = _celSize * (_celIndex % _celxCount);
      _cel.right = _cel.left + _celSize;
      _cel.top = _celSize * (_celIndex / _celxCount);
      _cel.bottom = _cel.top + _celSize;
      touch();
   }

   public void paint (Pen pp)
   {
      pp.drawBitmap (0, 0, _bmp, _cel);
   }

   int _type;
   Bitmap _bmp;
   Rect _cel;
   int _celSize;
   int _celCount;
   int _celxCount;
   int _celyCount;
   int _celIndex;
}

