package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class BaseSprite extends MapSprite
{
   static final int BASE_1 = 1;

   public BaseSprite (int type, float xWorld, float yWorld)
   {
      super (Xaiden.window(), Layout.DEPTH_BASE, Layout.PARALLAX_BASE);

      _type = type;
      _bmp = pickImage();

      _celSize = _bmp.getHeight() / 4;
      _celxCount = _bmp.getWidth() / _celSize;
      _celyCount = _bmp.getHeight() / _celSize;
      _celCount = _celxCount * _celyCount;
      _celIndex = 0;
      _cel = new Rect();
      _cel.left = _cel.top = 0;
      _cel.right = _cel.bottom = _celSize;

      setWorldPlacement (xWorld, yWorld, _cel);
      _pointer = new PointerSprite (PointerSprite.POINTER_BASE, this);
   }

   public void destroy()
   {
      _pointer.destroy();
      super.destroy();
   }

   Bitmap pickImage()
   {
      // (_type == BASE_1)
         return Xaiden.res().getTransparentBitmap (Resources.IDB_BASE_1);
   }

   public void update()
   {
      super.update();
      _celIndex = (_celIndex+1) % _celCount;
      _cel.left = _celSize * (_celIndex % _celxCount);
      _cel.right = _cel.left + _celSize;
      _cel.top = _celSize * (_celIndex / _celxCount);
      _cel.bottom = _cel.top + _celSize;
      touch();
   }

   public void paint (Pen pp)
   {
      pp.drawBitmap (0, 0, _bmp, _cel);
   }

   int _type;
   Bitmap _bmp;
   Rect _cel;
   int _celSize;
   int _celCount;
   int _celxCount;
   int _celyCount;
   int _celIndex;
   PointerSprite _pointer;
}

