package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class BeamSprite extends AnimSprite
{
   public BeamSprite (AnimSprite spFrom, AnimSprite spTo)
   {
      super (Xaiden.window(), Layout.DEPTH_BEAM);
      _spFrom = spFrom;
      _spTo = spTo;
      _direction = DIRECTION_NONE;
      _canhit = HITWALL_NONE;
      _adjust = new int [ADJUSTCOUNT_MAX];
      _width = BEAMWIDTH_DEFAULT;
      _clr1 = new Color(255,255,255);
      _clr2 = new Color(192,192,96);
      _clr3 = new Color(80,80,20);

      reposition();
      retarget();
   }

   void reposition()
   {
      Rect rFrom = _spFrom.pos;
      Rect rTo = _spTo.pos;

      Rect rr;
      rr = new Rect(rFrom);
      rr.union (rTo);
      setRect(rr);

      int dx, dy;
      if ((dx = (rTo.left - rFrom.right)) > 0)
      {
         if ((dy = (rFrom.top - rTo.bottom)) > 0)
         {
            _direction = (dx > dy) ? DIRECTION_LEFTRIGHT : DIRECTION_UPDOWN;
            _xFrom = rFrom.right - rr.left;
            _yFrom = rFrom.top - rr.top;
            _canhit = HITWALL_LEFT | HITWALL_BOTTOM;
         }
         else if ((dy = (rTo.top - rFrom.bottom)) > 0)
         {
            _direction = (dx > dy) ? DIRECTION_LEFTRIGHT : DIRECTION_UPDOWN;
            _xFrom = rFrom.right - rr.left;
            _yFrom = rFrom.bottom - rr.top;
            _canhit = HITWALL_LEFT | HITWALL_TOP;
         }
         else
         {
            _direction = DIRECTION_LEFTRIGHT;
            _xFrom = rFrom.right - rr.left;
            _yFrom = (rFrom.top + rFrom.bottom)/2 - rr.top;
            _canhit = HITWALL_LEFT;
         }
      }
      else if ((dx = (rFrom.left - rTo.right)) > 0)
      {
         if ((dy = (rFrom.top - rTo.bottom)) > 0)
         {
            _direction = (dx > dy) ? DIRECTION_LEFTRIGHT : DIRECTION_UPDOWN;
            _xFrom = rFrom.left - rr.left;
            _yFrom = rFrom.top - rr.top;
            _canhit = HITWALL_RIGHT | HITWALL_BOTTOM;
         }
         else if ((dy = (rTo.top - rFrom.bottom)) > 0)
         {
            _direction = (dx > dy) ? DIRECTION_LEFTRIGHT : DIRECTION_UPDOWN;
            _xFrom = rFrom.left - rr.left;
            _yFrom = rFrom.bottom - rr.top;
            _canhit = HITWALL_RIGHT | HITWALL_TOP;
         }
         else
         {
            _direction = DIRECTION_LEFTRIGHT;
            _xFrom = rFrom.left - rr.left;
            _yFrom = (rFrom.top + rFrom.bottom)/2 - rr.top;
            _canhit = HITWALL_RIGHT;
         }
      }
      else
      {
         if ((dy = (rFrom.top - rTo.bottom)) > 0)
         {
            _direction = DIRECTION_UPDOWN;
            _xFrom = (rFrom.left+rFrom.right)/2 - rr.left;
            _yFrom = rFrom.top - rr.top;
            _canhit = HITWALL_BOTTOM;
         }
         else if ((dy = (rTo.top - rFrom.bottom)) > 0)
         {
            _direction = (dx > dy) ? DIRECTION_LEFTRIGHT : DIRECTION_UPDOWN;
            _xFrom = (rFrom.left+rFrom.right)/2 - rr.left;
            _yFrom = rFrom.bottom - rr.top;
            _canhit = HITWALL_TOP;
         }
         else
         {
            _direction = DIRECTION_NONE;
            _canhit = HITWALL_NONE;
         }
      }
   }

   void findWall()
   {
      _xyWallTotal = 0;
      if ((_canhit & (HITWALL_LEFT | HITWALL_RIGHT)) != 0)
         _xyWallTotal += _spTo.pos.bottom - _spTo.pos.top;
      if ((_canhit & (HITWALL_TOP | HITWALL_BOTTOM)) != 0)
         _xyWallTotal += _spTo.pos.right - _spTo.pos.left;
   }

   void adjustTarget()
   {
      /*
      int xyRemaining = _cWall.get() % _xyWallTotal;
      int hitwall = _canhit;

      if ((_canhit & (HITWALL_LEFT | HITWALL_RIGHT)) != 0)
      {
         int thisWall = _spTo.pos.bottom - _spTo.pos.top;
         if (xyRemaining >= thisWall)
         {
            xyRemaining -= thisWall;
            hitwall &= ~(HITWALL_LEFT | HITWALL_RIGHT);
         }
      }

      if ((_canhit & (HITWALL_TOP | HITWALL_BOTTOM)) != 0)
      {
         int thisWall = _spTo.pos.right - _spTo.pos.left;
         if (xyRemaining >= thisWall)
         {
            xyRemaining -= thisWall;
            hitwall &= ~(HITWALL_TOP | HITWALL_BOTTOM);
         }
      }

      if ((_canhit & (HITWALL_LEFT | HITWALL_RIGHT)) != 0)
      {
         _xTo = (((_canhit & HITWALL_LEFT) != 0) ? _spTo.pos.left : _spTo.pos.right) - pos.left;
         _yTo = _spTo.pos.top - pos.top + xyRemaining;
      }
      else
      {
         _xTo = _spTo.pos.left - pos.left + xyRemaining;
         _yTo = (((_canhit & HITWALL_TOP) != 0) ? _spTo.pos.top : _spTo.pos.bottom) - pos.top;
      }
      */

      if ((_canhit & (HITWALL_LEFT | HITWALL_RIGHT)) != 0)
         _yTo = (_spTo.pos.top + _spTo.pos.bottom)/2 - pos.top;
      else if ((_canhit & HITWALL_TOP) != 0)
         _yTo = _spTo.pos.top - pos.top;
      else // ((_canhit & HITWALL_BOTTOM) != 0)
         _yTo = _spTo.pos.bottom - pos.top;

      if ((_canhit & (HITWALL_TOP | HITWALL_BOTTOM)) != 0)
         _xTo = (_spTo.pos.left + _spTo.pos.right)/2 - pos.left;
      else if ((_canhit & HITWALL_LEFT) != 0)
         _xTo = _spTo.pos.left - pos.left;
      else // ((_canhit & HITWALL_RIGHT) != 0)
         _xTo = _spTo.pos.right - pos.left;
   }

   void adjustCreepers()
   {
      if (_direction == DIRECTION_LEFTRIGHT)
      {
         int dxToTarget = Math.abs(_xTo - _xFrom);
         int yTopToTarget = _yTo - dxToTarget * BEAMDISPERSION_MAX;
         int yBottomToTarget = _yTo + dxToTarget * BEAMDISPERSION_MAX;
         int yTopFromSource = _yFrom;
         int yBottomFromSource = _yFrom;

         int adj = 0;
         for (int dx = 0; dx < dxToTarget; dx += ADJUST_SPACING)
         {
            yTopToTarget += ADJUST_SPACING * BEAMDISPERSION_MAX;
            yBottomToTarget -= ADJUST_SPACING * BEAMDISPERSION_MAX;
            yTopFromSource -= ADJUST_SPACING * BEAMDISPERSION_MAX;
            yBottomFromSource += ADJUST_SPACING * BEAMDISPERSION_MAX;

            int yTop = (yTopToTarget > yTopFromSource) ? yTopToTarget : yTopFromSource;
            int yBottom = (yBottomToTarget < yBottomFromSource) ? yBottomToTarget : yBottomFromSource;

            if (yBottom <= yTop)
               _adjust[adj] = 0;
            else
               _adjust[adj] = Math.abs(_randgen.nextInt()) % (yBottom - yTop) - (yBottom - yTop)/2;
            ++adj;
         }
      }
      else
      {
         int dyToTarget = Math.abs(_yTo - _yFrom);
         int xLeftToTarget = _xTo - dyToTarget * BEAMDISPERSION_MAX;
         int xRightToTarget = _xTo + dyToTarget * BEAMDISPERSION_MAX;
         int xLeftFromSource = _xFrom;
         int xRightFromSource = _xFrom;

         int adj = 0;
         for (int dy = 0; dy < dyToTarget; dy += ADJUST_SPACING)
         {
            xLeftToTarget += ADJUST_SPACING * BEAMDISPERSION_MAX;
            xRightToTarget -= ADJUST_SPACING * BEAMDISPERSION_MAX;
            xLeftFromSource -= ADJUST_SPACING * BEAMDISPERSION_MAX;
            xRightFromSource += ADJUST_SPACING * BEAMDISPERSION_MAX;

            int xLeft = (xLeftToTarget > xLeftFromSource) ? xLeftToTarget : xLeftFromSource;
            int xRight = (xRightToTarget < xRightFromSource) ? xRightToTarget : xRightFromSource;

            if (xRight <= xLeft)
               _adjust[adj] = 0;
            else
               _adjust[adj] = Math.abs(_randgen.nextInt()) % (xRight - xLeft) - (xRight - xLeft)/2;
            ++adj;
         }
      }
   }

   void adjust()
   {
      findWall();
      _cWall.update();
      adjustTarget();
      adjustCreepers();
   }

   void retarget()
   {
      findWall();
      _cWall = new Creeper(Creeper.TYPE_ZEROPLUS, _xyWallTotal);
      adjustTarget();
      adjustCreepers();
   }

   public void update ()
   {
      int dirLast = _direction;
      int hitLast = _canhit;
      int xyWallLast = _xyWallTotal;

      reposition();

      if (_direction == DIRECTION_NONE)
         return;

      if ((dirLast != _direction) || (hitLast != _canhit) || (xyWallLast != _xyWallTotal))
         retarget();
      else
         adjust();
   }

   public void paintLR (Pen pp, int xx, int yy)
   {
      int w = _width/2;
      pp.setColor (_clr2);
      for (int ii = yy-w+1; ii < yy+w; ++ii)
         pp.drawPoint (xx, ii);

      pp.setColor (_clr3);
      pp.drawPoint (xx, yy-w);
      pp.drawPoint (xx, yy+w);

      pp.setColor (_clr1);
      pp.drawPoint (xx, yy);
   }

   public void paintUD (Pen pp, int xx, int yy)
   {
      int w = _width/2;
      pp.setColor (_clr2);
      for (int ii = xx-w+1; ii < xx+w; ++ii)
         pp.drawPoint (ii, yy);

      pp.setColor (_clr3);
      pp.drawPoint (xx-w, yy);
      pp.drawPoint (xx+w, yy);

      pp.setColor (_clr1);
      pp.drawPoint (xx, yy);
   }

   public void paintTowardsR (Pen pp, int xx, int yy)
   {
      if (_xPaint < xx)
      {
         float dyPerX = (float)(yy - _yPaint) / (xx - _xPaint);
         if (dyPerX > BEAMDISPERSION_MAX)
            dyPerX = BEAMDISPERSION_MAX;
         else if (dyPerX < 0-BEAMDISPERSION_MAX)
            dyPerX = 0-BEAMDISPERSION_MAX;
         while (_xPaint < xx)
         {
            paintLR (pp, (int)_xPaint, (int)_yPaint);
            _xPaint += 1;
            _yPaint += dyPerX;
         }
      }
   }

   public void paintTowardsL (Pen pp, int xx, int yy)
   {
      if (_xPaint > xx)
      {
         float dyPerX = (float)(yy - _yPaint) / (_xPaint - xx);
         if (dyPerX > BEAMDISPERSION_MAX)
            dyPerX = BEAMDISPERSION_MAX;
         else if (dyPerX < 0-BEAMDISPERSION_MAX)
            dyPerX = 0-BEAMDISPERSION_MAX;
         while (_xPaint > xx)
         {
            paintLR (pp, (int)_xPaint, (int)_yPaint);
            _xPaint -= 1;
            _yPaint += dyPerX;
         }
      }
   }

   public void paintTowardsU (Pen pp, int xx, int yy)
   {
      if (_yPaint < yy)
      {
         float dxPerY = (float)(xx - _xPaint) / (yy - _yPaint);
         if (dxPerY > BEAMDISPERSION_MAX)
            dxPerY = BEAMDISPERSION_MAX;
         else if (dxPerY < 0-BEAMDISPERSION_MAX)
            dxPerY = 0-BEAMDISPERSION_MAX;
         while (_yPaint < yy)
         {
            paintLR (pp, (int)_xPaint, (int)_yPaint);
            _xPaint += dxPerY;
            _yPaint += 1;
         }
      }
   }

   public void paintTowardsD (Pen pp, int xx, int yy)
   {
      if (_yPaint > yy)
      {
         float dxPerY = (float)(xx - _xPaint) / (_yPaint - yy);
         if (dxPerY > BEAMDISPERSION_MAX)
            dxPerY = BEAMDISPERSION_MAX;
         else if (dxPerY < 0-BEAMDISPERSION_MAX)
            dxPerY = 0-BEAMDISPERSION_MAX;
         while (_yPaint > yy)
         {
            paintLR (pp, (int)_xPaint, (int)_yPaint);
            _xPaint += dxPerY;
            _yPaint -= 1;
         }
      }
   }

   public void paint (Pen pp)
   {
      if (_direction != DIRECTION_NONE)
      {
         _xPaint = _xFrom;
         _yPaint = _yFrom;

         int adj = 0;
         if (_direction == DIRECTION_LEFTRIGHT)
         {
            if (_xTo > _xFrom)
            {
               for (int xx = _xFrom + ADJUST_SPACING; xx < _xTo; xx += ADJUST_SPACING)
                  paintTowardsR (pp, xx, _yFrom + (_yTo - _yFrom) * (xx - _xFrom) / (_xTo - _xFrom) + _adjust[adj++]);
            }
            else
            {
               for (int xx = _xFrom - ADJUST_SPACING; xx > _xTo; xx -= ADJUST_SPACING)
                  paintTowardsL (pp, xx, _yFrom + (_yTo - _yFrom) * (xx - _xTo) / (_xFrom - _xTo) + _adjust[adj++]);
            }
         }
         else if (_direction == DIRECTION_UPDOWN)
         {
            if (_yTo > _yFrom)
            {
               for (int yy = _yFrom + ADJUST_SPACING; yy < _yTo; yy += ADJUST_SPACING)
                  paintTowardsU (pp, _xFrom + (_xTo - _xFrom) * (yy - _yFrom) / (_yTo - _yFrom) + _adjust[adj++], yy);
            }
            else if (_yFrom > _yTo)
            {
               for (int yy = _yFrom - ADJUST_SPACING; yy > _yTo; yy -= ADJUST_SPACING)
                  paintTowardsD (pp, _xFrom + (_xTo - _xFrom) * (yy - _yTo) / (_yFrom - _yTo) + _adjust[adj++], yy);
            }
         }
      }
   }

   static Random _randgen = new Random();
   AnimSprite _spFrom;
   AnimSprite _spTo;
   int _xFrom;
   int _yFrom;

   static final int DIRECTION_NONE = 0;
   static final int DIRECTION_LEFTRIGHT = 1;
   static final int DIRECTION_UPDOWN = 2;
   int _direction;

   static final int HITWALL_NONE = 0;
   static final int HITWALL_LEFT = 1;
   static final int HITWALL_TOP = 2;
   static final int HITWALL_RIGHT = 4;
   static final int HITWALL_BOTTOM = 8;
   int _canhit;
   int _xyWallTotal;
   Creeper _cWall;
   int _xTo;
   int _yTo;
   int _width;
   Color _clr1;
   Color _clr2;
   Color _clr3;

   static final int ADJUST_SPACING = 1;
   static final int ADJUSTCOUNT_MAX = Layout.WIDTH_SCREEN / ADJUST_SPACING;
   int _adjust[];

   static final int BEAMWIDTH_DEFAULT = 7;
   static final int BEAMDISPERSION_MAX = 2;
   float _xPaint;
   float _yPaint;
}

