package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class BulletSprite extends MapSprite
{
   static final float SPEED_BULLET = 10f;
   public static final int SIZE_BULLETSPRITE = 12;

   static final int BULLET_1_SMALL = 1;
   static final int BULLET_1_BIG = 2;
   static final int BULLET_1_MEGA = 3;

   static final int BULLET_2_SMALL = 4;
   static final int BULLET_2_BIG = 5;
   static final int BULLET_2_MEGA = 6;

   static final int BULLET_3_SMALL = 7;
   static final int BULLET_3_BIG = 8;
   static final int BULLET_3_MEGA = 9;

   static final int BULLET_4 = 10;

   public BulletSprite (int type, int repeat, int dxFacing, int dyFacing)
   {
      super (Xaiden.window(), Layout.DEPTH_BULLET, Layout.PARALLAX_BULLET);

      ShipMotion ship = Xaiden.game().getShipMovement();

      _type = type;
      float speed = pickSpeed();

      if (Xaiden.settings().useEasyBullets && false)
         _move = new ObjectMotion (speed * dxFacing, speed * dyFacing);
      else
         _move = new ObjectMotion (speed * dxFacing + ship.dx, speed * dyFacing + ship.dy);

      _bmp = Xaiden.res().getTransparentBitmap (Resources.IDB_BULLETS);

      pickCel();
      pickLocation(repeat);
   }

   float pickSpeed()
   {
      return SPEED_BULLET;
   }

   void pickCel()
   {
      _cel = new Rect();

      if ((_type == BULLET_1_SMALL) || (_type == BULLET_2_SMALL) || (_type == BULLET_3_SMALL) || (_type == BULLET_4))
         _cel.left = 0;
      else if ((_type == BULLET_1_BIG) || (_type == BULLET_2_BIG) || (_type == BULLET_3_BIG))
         _cel.left = SIZE_BULLETSPRITE;
      else // ((_type == BULLET_1_MEGA) || (_type == BULLET_2_MEGA) || (_type == BULLET_3_MEGA))
         _cel.left = SIZE_BULLETSPRITE*2;
      _cel.right = _cel.left + SIZE_BULLETSPRITE;

      if ((_type == BULLET_1_SMALL) || (_type == BULLET_1_BIG) || (_type == BULLET_1_MEGA))
         _cel.top = 0;
      else if ((_type == BULLET_2_SMALL) || (_type == BULLET_2_BIG) || (_type == BULLET_2_MEGA))
         _cel.top = SIZE_BULLETSPRITE;
      else if ((_type == BULLET_3_SMALL) || (_type == BULLET_3_BIG) || (_type == BULLET_3_MEGA))
         _cel.top = SIZE_BULLETSPRITE*2;
      else // (_type == BULLET_4)
         _cel.top = SIZE_BULLETSPRITE*3;
      _cel.bottom = _cel.top + SIZE_BULLETSPRITE;
   }

   void pickLocation (int count)
   {
      Rect rr = new Rect();
      rr.left = (Layout.WIDTH_SCREEN - SIZE_BULLETSPRITE)/2;
      rr.top = (Layout.HEIGHT_SCREEN - SIZE_BULLETSPRITE)/2;
      rr.right = rr.left + SIZE_BULLETSPRITE;
      rr.bottom = rr.top + SIZE_BULLETSPRITE;
      setRect(rr);

      moveMultiplied (_move, 2f - count);

      adjustSprite();
   }

   public void adjust (ObjectMotion shipMotion)
   {
      moveBackwards (shipMotion);
      move (_move);
      adjustSprite();

      if (!isOnScreen())
         destroy();
   }

   public void update()
   {
      if (_type == BULLET_4)
      {
         _cel.left = (_cel.left + SIZE_BULLETSPRITE) % (SIZE_BULLETSPRITE*3);
         _cel.right = _cel.left + SIZE_BULLETSPRITE;
      }
      touch();
   }

   public void paint (Pen pp)
   {
      pp.drawBitmap (0, 0, _bmp, _cel);
   }

   int _type;
   Bitmap _bmp;
   Rect _cel;
   ObjectMotion _move;
}

