package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Controller implements InputListener
{
   public Controller()
   {
      _active = false;
   }

   public void suspend()
   {
      if (_active)
      {
         Xaiden.game().controller().onSuspend();
         Meta.unmuteID(Meta.FEEDBACK_KEY_ONCE);
         Meta.unmuteID(Meta.FEEDBACK_KEY_REPEAT);
         Meta.unmuteID(Meta.FEEDBACK_BACK_BUTTON);
         Meta.unmuteID(Meta.FEEDBACK_CANCEL_BUTTON);
         Meta.unmuteID(Meta.FEEDBACK_MENU_BUTTON);
         Meta.unmuteID(Meta.FEEDBACK_WHEEL_BUTTON);
         Meta.unmuteID(Meta.SCROLL_WHEEL_DOWN);
         Meta.unmuteID(Meta.SCROLL_WHEEL_UP);
         _active = false;
      }
   }

   public void resume()
   {
      if (!_active)
      {
         Meta.muteID(Meta.FEEDBACK_KEY_ONCE);
         Meta.muteID(Meta.FEEDBACK_KEY_REPEAT);
         Meta.muteID(Meta.FEEDBACK_BACK_BUTTON);
         Meta.muteID(Meta.FEEDBACK_CANCEL_BUTTON);
         Meta.muteID(Meta.FEEDBACK_MENU_BUTTON);
         Meta.muteID(Meta.FEEDBACK_WHEEL_BUTTON);
         Meta.muteID(Meta.SCROLL_WHEEL_DOWN);
         Meta.muteID(Meta.SCROLL_WHEEL_UP);
         _active = true;
      }
   }

   public boolean consume (int c)
   {
      switch (c) {
         case Event.DEVICE_ARROW_DOWN:
         case Event.DEVICE_ARROW_LEFT:
         case Event.DEVICE_ARROW_RIGHT:
         case Event.DEVICE_ARROW_UP:
         case Event.DEVICE_ARROW_DOWN_LEFT:
         case Event.DEVICE_ARROW_DOWN_RIGHT:
         case Event.DEVICE_ARROW_UP_LEFT:
         case Event.DEVICE_ARROW_UP_RIGHT:
         case Event.DEVICE_WHEEL_BUTTON:
         case GameController.KEY_FIRE:
            return true;
      }
      return false;
   }

   public boolean eventKeyDown (char c, Event e)
   {
      if (Xaiden.window().ready())
      {
         GameMenu menu;
         if ((menu = Xaiden.window().menu()) != null)
            menu.onKeyDown(c);
         else
            Xaiden.game().controller().onKeyDown(c);
      }
      return consume(c);
   }

   public boolean eventKeyUp (char c, Event e)
   {
      if (Xaiden.window().ready())
      {
         GameMenu menu;
         if ((menu = Xaiden.window().menu()) != null)
            menu.onKeyUp(c);
         else
            Xaiden.game().controller().onKeyUp(c);
      }
      return consume(c);
   }

   public boolean eventKeyRepeat (char c, Event e)
   {
      return consume(c);
   }

   public boolean eventWidgetDown (int c, Event e)
   {
      if (Xaiden.window().ready())
      {
         GameMenu menu;
         if ((menu = Xaiden.window().menu()) != null)
            menu.onKeyDown(c);
         else
            Xaiden.game().controller().onKeyDown(c);
      }
      return consume(c);
   }

   public boolean eventWidgetUp (int c, Event e)
   {
      if (Xaiden.window().ready())
      {
         GameMenu menu;
         if ((menu = Xaiden.window().menu()) != null)
            menu.onKeyUp(c);
         else
            Xaiden.game().controller().onKeyUp(c);
      }
      return consume(c);
   }

   public boolean eventWidgetHeld (int c, Event e)
   {
      return consume(c);
   }

   boolean _active;
}

