package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Creeper
{
   static final int REMAINTIME_MIN = 5;
   static final int REMAINTIME_RANGE = 15;

   static final float ADJUST_MIN = -2f;
   static final float ADJUST_MAX = 2f;

   static final int TYPE_ZEROPLUS = 0;
   static final int TYPE_CENTERED = 1;

   public Creeper()
   {
      _offset = 0f;
      _range = _now = _dir = 0f;
      _remaining = 0;
   }

   public Creeper (int type, int range)
   {
      _offset = 0f;
      _range = _now = _dir = 0f;
      _remaining = 0;
      setRange(type, range);
   }

   public void setRange (int type, int range)
   {
      _offset = (type == TYPE_ZEROPLUS) ? 0f : (0 - (float)range / 2f);
      if (((range != 0) && (_range == 0)) || (_now > range))
      {
         _now = (float)(Math.abs(_randgen.nextInt()) % range);
         _dir = 0f;
         _remaining = 0;
      }
      _range = range;
   }

   public int get()
   {
      return (int)(_now + _offset);
   }

   public void update()
   {
      if (_range == 0f)
         return;

      if ((_dir == 0f) || (_now + _dir < 0) || (_now + _dir >= _range))
         _remaining = 0;

      if (--_remaining > 0)
      {
         _now += _dir;
      }
      else
      {
         _remaining = REMAINTIME_MIN + Math.abs(_randgen.nextInt()) % REMAINTIME_RANGE;
         _dir = (float)(Math.abs(_randgen.nextInt()) % (int)((ADJUST_MAX - ADJUST_MIN) * 1000f)) / 1000f + ADJUST_MIN;

         if ((_dir < 0f) && (_now + _dir < 0f))
            _dir = 0f - _dir;
         else if ((_dir > 0f) && (_now + _dir >= _range))
            _dir = 0f - _dir;
      }
   }

   static Random _randgen = new Random();
   float _range;
   float _now;
   float _dir;
   float _offset;
   int _remaining;
}

