package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Game
{
   public Game()
   {
      _controller = new GameController();
      _shipMotion = new ShipMotion();
      _shipSprite = null;
      _stars = new StarField();
      _map = new Map();
      _haveGame = false;
      _menuMotion = new ObjectMotion (0.5f, 0f);

//    _shipSprite = new ShipSprite();
//    _map.addSprite (new BaseSprite (1, 0.1f, 0f));
//    _map.addSprite (new BaseSprite (1, 0.2f, 0.1f));
   }

   public void setShipMovement (int dx, int dy)
   {
      if (_shipSprite != null) {
         _shipSprite.setDirection (dx, dy);
         _shipMotion.setDirection (dx, dy);
      }
   }

   public ShipMotion getShipMovement()
   {
      return _shipMotion;
   }

   public GameController controller()
   {
      return _controller;
   }

   public void onFrame()
   {
      if (!Xaiden.window().ready())
         return;

      if (Xaiden.window().menu() != null)
      {
         _stars.adjust (_menuMotion);
         Xaiden.window().adjust (_menuMotion);
      }
      else
      {
         _shipMotion.onFrame();
         _stars.adjust (_shipMotion);
         _map.adjust (_shipMotion);
         Xaiden.window().adjust (_shipMotion);
      }
   }

   public void onFire()
   {
      for (int ii = 0; ii < 3; ++ii)
      {
         _map.addSprite (new BulletSprite (BulletSprite.BULLET_4, ii, _shipMotion.dxFacing, _shipMotion.dyFacing));
      }
   }

   public Map map()
   {
      return _map;
   }

   public boolean haveGame()
   {
      return _haveGame;
   }

   GameController _controller;
   ShipSprite _shipSprite;
   ShipMotion _shipMotion;
   ObjectMotion _menuMotion;
   StarField _stars;
   Map _map;
   boolean _haveGame;
}

