package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class GameController
{
   public static final char KEY_FIRE  = ' ';

   public GameController()
   {
      _leftDown = false;
      _rightDown = false;
      _upDown = false;
      _downDown = false;
   }

   public void onSuspend()
   {
      _leftDown = false;
      _rightDown = false;
      _upDown = false;
      _downDown = false;
      Xaiden.game().setShipMovement (0, 0);
   }

   public void onKeyDown (int c)
   {
      switch (c) {
         case KEY_FIRE:
            Xaiden.game().onFire();
            break;

         case Event.DEVICE_ARROW_DOWN:
            _downDown = true;  _upDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_LEFT:
            _leftDown = true;  _rightDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_RIGHT:
            _rightDown = true;  _leftDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_UP:
            _upDown = true;  _downDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_DOWN_LEFT:
            _leftDown = true;  _rightDown = false;
            _downDown = true;  _upDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_DOWN_RIGHT:
            _rightDown = true;  _leftDown = false;
            _downDown = true;  _upDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_UP_LEFT:
            _leftDown = true;  _rightDown = false;
            _upDown = true;  _downDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_UP_RIGHT:
            _rightDown = true;  _leftDown = false;
            _upDown = true;  _downDown = false;
            onShipChange();
            break;

         case Event.DEVICE_WHEEL_BUTTON:
            Xaiden.game().onFire();
            break;
      }
   }

   public void onKeyUp (int c)
   {
      switch (c) {
         case Event.DEVICE_ARROW_DOWN:
            _downDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_LEFT:
            _leftDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_RIGHT:
            _rightDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_UP:
            _upDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_DOWN_LEFT:
            _leftDown = _downDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_DOWN_RIGHT:
            _rightDown = _downDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_UP_LEFT:
            _leftDown = _upDown = false;
            onShipChange();
            break;

         case Event.DEVICE_ARROW_UP_RIGHT:
            _rightDown = _upDown = false;
            onShipChange();
            break;
      }
   }

   void onShipChange()
   {
      if (_leftDown)
      {
         if (_upDown)
            Xaiden.game().setShipMovement (-1, -1);
         else if (_downDown)
            Xaiden.game().setShipMovement (-1, 1);
         else
            Xaiden.game().setShipMovement (-1, 0);
      }
      else if (_rightDown)
      {
         if (_upDown)
            Xaiden.game().setShipMovement (1, -1);
         else if (_downDown)
            Xaiden.game().setShipMovement (1, 1);
         else
            Xaiden.game().setShipMovement (1, 0);
      }
      else
      {
         if (_upDown)
            Xaiden.game().setShipMovement (0, -1);
         else if (_downDown)
            Xaiden.game().setShipMovement (0, 1);
         else
            Xaiden.game().setShipMovement (0, 0);
      }
   }

   boolean _leftDown;
   boolean _rightDown;
   boolean _upDown;
   boolean _downDown;
}

