package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class GameMenu
{
   public static final int MENU_MAIN = 1;
   public static final int MENU_RESUME = 2;

   static final int IMAGE_MENU_PLAY = 0;
   static final int IMAGE_MENU_SCORES = 1;
   static final int IMAGE_MENU_OPTIONS = 2;
   static final int IMAGE_MENU_HELP = 3;
   static final int IMAGE_MENU_RESUME = 4;
   static final int IMAGE_MENU_CANCEL = 5;

   public GameMenu (int type)
   {
      _type = type;
      _title = new TitleSprite();
      _base = new BaseMenuSprite();
      _selected = 0;
      _beam = null;

      Bitmap bmp = Xaiden.res().getTransparentBitmap (Resources.IDB_MENUTEXT);

      if (_type == MENU_MAIN)
      {
         _count = 4;
         _menu = new MenuSprite[_count];
         _menu[0] = new MenuSprite (bmp, 0, IMAGE_MENU_PLAY, ResourceEvents.EVENT_MENU_PLAY);
         _menu[1] = new MenuSprite (bmp, 1, IMAGE_MENU_SCORES, ResourceEvents.EVENT_MENU_SCORES);
         _menu[2] = new MenuSprite (bmp, 2, IMAGE_MENU_OPTIONS, ResourceEvents.EVENT_MENU_OPTIONS);
         _menu[3] = new MenuSprite (bmp, 3, IMAGE_MENU_HELP, ResourceEvents.EVENT_MENU_HELP);
      }
      else
      {
         _count = 4;
         _menu = new MenuSprite[_count];
         _menu[0] = new MenuSprite (bmp, 0, IMAGE_MENU_PLAY, ResourceEvents.EVENT_MENU_RESUME);
         _menu[1] = new MenuSprite (bmp, 1, IMAGE_MENU_OPTIONS, ResourceEvents.EVENT_MENU_CANCEL);
         _menu[2] = new MenuSprite (bmp, 2, IMAGE_MENU_SCORES, ResourceEvents.EVENT_MENU_OPTIONS);
         _menu[3] = new MenuSprite (bmp, 3, IMAGE_MENU_HELP, ResourceEvents.EVENT_MENU_HELP);
      }

      changeSelection(0);
   }

   public void destroy()
   {
      if (_menu != null)
      {
         for (int ii = 0; ii < _count; ++ii)
            _menu[ii].destroy();
      }
      _menu = null;

      if (_title != null)
         _title.destroy();
      _title = null;

      if (_base != null)
         _base.destroy();
      _base = null;

      if (_beam != null)
         _beam.destroy();
      _beam = null;
   }

   public void onKeyDown (int c)
   {
      switch (c)
      {
         case Event.DEVICE_ARROW_DOWN:
         case Event.DEVICE_WHEEL:
            changeSelection(1);
            break;

         case Event.DEVICE_ARROW_UP:
            changeSelection(-1);
            break;
      }
   }

   public void onKeyUp (int c)
   {
      switch (c)
      {
         case Event.DEVICE_WHEEL:
            changeSelection(-1);
            break;
      }
   }

   public void changeSelection (int dd)
   {
      if (_beam != null)
         _beam.destroy();
      _menu[ _selected ].setSelected (false);

      _selected += dd;
      if (_selected < 0)
         _selected = 0;
      else if (_selected >= _count)
         _selected = _count-1;

      _menu[ _selected ].setSelected (true);
      _beam = new BeamSprite (_base, _menu[ _selected ]);
   }

   int _type;
   TitleSprite _title;
   BaseMenuSprite _base;
   MenuSprite _menu[];
   BeamSprite _beam;
   int _count;
   int _selected;
}

