package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Map
{
   public Map()
   {
      _spriteCount = 0;
      _spriteMax = 1;
      _sprites = new MapSprite[_spriteMax];
   }

   public void adjust (ObjectMotion shipMotion)
   {
      for (int ii = 0; ii < _spriteCount; ++ii)
      {
         for (;;)
         {
            MapSprite moOrig = _sprites[ii];
            moOrig.adjust (shipMotion);
            if (ii >= _spriteCount)
               break;
            if (moOrig == _sprites[ii])
               break;
         }
      }
   }

   public void addSprite (MapSprite mo)
   {
      if (_spriteCount + 1 >= _spriteMax)
      {
         int newMax = _spriteMax + 10;
         MapSprite[] newArray = new MapSprite[ newMax ];
         for (int ii = 0; ii < _spriteCount; ++ii)
         {
            newArray[ii] = _sprites[ii];
            _sprites[ii] = null;
         }
         _spriteMax = newMax;
         _sprites = newArray;
      }

      mo._mapIndex = _spriteCount;
      _sprites[ _spriteCount++ ] = mo;
   }

   public void removeSprite (MapSprite mo)
   {
      if (mo._mapIndex + 1 == _spriteCount)
      {
         _sprites[ mo._mapIndex ] = null;
      }
      else
      {
         _sprites[ mo._mapIndex ] = _sprites[ _spriteCount-1 ];
         _sprites[ mo._mapIndex ]._mapIndex = mo._mapIndex;
         _sprites[ _spriteCount-1 ] = null;
      }
      mo._mapIndex = -1;
      _spriteCount--;
   }

   int _spriteCount;
   int _spriteMax;
   MapSprite[] _sprites;
}

