package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class MenuSprite extends AnimSprite
{
   static final int MENU_BUTTON_COUNT = 6;
   static final int HEIGHT_FIRST_BUTTON = 52;
   static final int SPACE_BETWEEN_BUTTONS = 6;

   public MenuSprite (Bitmap bmp, int visualIndex, int imageIndex, int event)
   {
      super (Xaiden.window(), Layout.DEPTH_TITLE);
      _bmp = bmp;
      _selected = false;
      _imageIndex = imageIndex;
      _event = event;

      int cx = _bmp.getWidth() / 2;
      int cy = _bmp.getHeight() / MENU_BUTTON_COUNT;

      Rect rr = new Rect();
      rr.right = Layout.WIDTH_SCREEN - 5;
      rr.left = rr.right - cx;
      rr.top = HEIGHT_FIRST_BUTTON + (cy + SPACE_BETWEEN_BUTTONS) * visualIndex;
      rr.bottom = rr.top + cy;
      setRect(rr);

      pickCel();
   }

   public void pickCel()
   {
      int cx = _bmp.getWidth() / 2;
      int cy = _bmp.getHeight() / MENU_BUTTON_COUNT;

      _cel = new Rect();
      _cel.left = (_selected) ? cx : 0;
      _cel.right = _cel.left + cx;
      _cel.top = cy * _imageIndex;
      _cel.bottom = _cel.top + cy;
   }

   public void setSelected (boolean ss)
   {
      if (ss != _selected)
      {
         _selected = ss;
         pickCel();
         touch();
      }
   }

   public void paint (Pen pp)
   {
      pp.drawBitmap (0, 0, _bmp, _cel);
   }

   Bitmap _bmp;
   Rect _cel;
   boolean _selected;
   int _imageIndex;
   int _event;
}

