package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class ObjectLocation
{
   float xx;
   float yy;

   public ObjectLocation()
   {
      _parallax = 1.0f;
      _xConsumed = _yConsumed = 0;
      xx = yy = 0;
   }

   public ObjectLocation (float parallax)
   {
      _parallax = parallax;
      _xConsumed = _yConsumed = 0;
      xx = yy = 0;
   }

   public void move (ObjectMotion om)
   {
      xx += om.dx * _parallax;
      yy += om.dy * _parallax;
   }

   public void moveBackwards (ObjectMotion om)
   {
      xx -= om.dx * _parallax;
      yy -= om.dy * _parallax;
   }

   public void adjustSprite (AnimSprite sprite)
   {
      int dx;
      if ((dx = (int)xx) != 0)
      {
         Rect rr = new Rect(sprite.pos);
         xx -= dx;
         rr.left += dx;
         rr.right += dx;
         sprite.setRect(rr);
      }

      int dy;
      if ((dy = (int)yy) != 0)
      {
         Rect rr = new Rect(sprite.pos);
         yy -= dy;
         rr.top += dy;
         rr.bottom += dy;
         sprite.setRect(rr);
      }
   }

   float _parallax;
   float _xConsumed;
   float _yConsumed;
}

