package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;
import com.randomsoftware.common.resloader.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class ResourceManager extends ResLoader
{
   public ResourceManager()
   {
      super (Xaiden.window(), new ResLoaderFullLogo (Resources.IDSND_LOGO));
   }

   public void load()
   {
      _bitmaps = new Bitmap[100];
      loadBitmap (Resources.IDB_BACKGROUND, OPAQUE);
      loadBitmap (Resources.IDB_BADDIE_1, TRANSPARENT);
      loadBitmap (Resources.IDB_BADDIE_2, TRANSPARENT);
      loadBitmap (Resources.IDB_BASE_1, TRANSPARENT);
      loadBitmap (Resources.IDB_TITLE, TRANSPARENT);
      loadBitmap (Resources.IDB_ROCK_1, TRANSPARENT);
      loadBitmap (Resources.IDB_SHIP, TRANSPARENT);
      loadBitmap (Resources.IDB_STAR_SHORT, OPAQUE);
      loadBitmap (Resources.IDB_STAR_TALL, OPAQUE);
      loadBitmap (Resources.IDB_STAR_GRANDE, OPAQUE);
      loadBitmap (Resources.IDB_STAR_VENTI, OPAQUE);
      loadBitmap (Resources.IDB_POINTER_UPDOWN, TRANSPARENT);
      loadBitmap (Resources.IDB_POINTER_LEFTRIGHT, TRANSPARENT);
      loadBitmap (Resources.IDB_BULLETS, TRANSPARENT);
      loadBitmap (Resources.IDB_MENUTEXT, TRANSPARENT);
   }

   public void unload()
   {
      _bitmaps = null;
   }

   public Bitmap getBitmap (int idb)
   {
      return _bitmaps[idb];
   }

   static final int TRANSPARENT = 1;
   static final int OPAQUE = 2;
   void loadBitmap (int idb, int type)
   {
      Bitmap bmp;
      if (type == TRANSPARENT)
         _bitmaps[idb] = Xaiden.res().getTransparentBitmap (idb);
      else // (type == OPAQUE)
         _bitmaps[idb] = Xaiden.res().getOpaqueBitmap (idb);
   }

   Bitmap[] _bitmaps;
}

