package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class RockSprite extends MapSprite
{
   static final int ROCK_1 = 1;

   public RockSprite (int type, float xWorld, float yWorld)
   {
      super (Xaiden.window(), Layout.DEPTH_ROCK, Layout.PARALLAX_ROCK);

      _type = type;
      _bmp = pickImage();

      _celSize = _bmp.getHeight();
      _celCount = _bmp.getWidth() / _celSize;
      _celIndex = (int)xWorld % _celCount;  // pseudo-random
      _cel = new Rect();
      _cel.left = _cel.top = 0;
      _cel.right = _cel.bottom = _celSize;

      setWorldPlacement (xWorld, yWorld, _cel);
   }

   Bitmap pickImage()
   {
      // (_type == ROCK_1)
         return Xaiden.res().getTransparentBitmap (Resources.IDB_ROCK_1);
   }

   public void update()
   {
      super.update();
      _celIndex = (_celIndex+1) % _celCount;
      _cel.left = _celSize * _celIndex;
      _cel.right = _cel.left + _celSize;
      touch();
   }

   public void paint (Pen pp)
   {
      pp.drawBitmap (0, 0, _bmp, _cel);
   }

   int _type;
   Bitmap _bmp;
   Rect _cel;
   int _celSize;
   int _celCount;
   int _celIndex;
}

