package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;

class Settings
{
   static final String sDatabaseName = "Settings";
   static final int currentVersion = 1;
   public boolean useEasyBullets;

   static final String LHS_NEXTVERSION = "version";
   static final String LHS_EASYBULLETS = "easyBullets";

   public Settings (Listener tell)
   {
      _db = new SettingsDB (sDatabaseName);
      _db.setAutoSyncNotifyee (tell);
      reload();
   }

   public void reload()
   {
      try
      {
         if (_db.getIntValue (LHS_NEXTVERSION) < currentVersion)
            throw new SettingsDBException();

         useEasyBullets = (_db.getIntValue (LHS_EASYBULLETS) != 0);
      }
      catch (SettingsDBException ee)
      {
         _db.clearAll();
         loadDefaults();
         save();
      }
   }

   public void loadDefaults()
   {
      useEasyBullets = true;
   }

   public void save()
   {
      _db.setIntValue (LHS_EASYBULLETS, (useEasyBullets) ? 1 : 0);
      _db.setIntValue (LHS_NEXTVERSION, currentVersion);
   }

   SettingsDB _db;
}

