package com.randomsoftware.xaiden;
import com.randomsoftware.common.animation.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class ShipMotion extends ObjectMotion
{
   int dxFacing;
   int dyFacing;

   int dxThrust;
   int dyThrust;

   ShipEngine engine = new ShipEngine();

   public ShipMotion()
   {
      super();
      dxFacing = dyFacing = 0;
      dxThrust = dyThrust = 0;
      _angleFacing = 0;
      _angleMoving = 0;
      _speedMoving = 0;
      buildTables();
   }

   public void setDirection (int dxIn, int dyIn)
   {
      if ((dxThrust != dxIn) || (dyThrust != dyIn))
      {
         dxThrust = dxIn;
         dyThrust = dyIn;
         if (dxThrust!=0 || dyThrust!=0)
         {
            dxFacing = dxIn;
            dyFacing = dyIn;
            _angleFacing = _facingAngles[dyIn+1][dxIn+1];
         }
      }
   }

   public void onFrame()
   {
      dx *= engine.Friction;
      dy *= engine.Friction;

      if (dxThrust!=0 || dyThrust!=0)
      {
         dx += engine.Acceleration * dxThrust;
         dy += engine.Acceleration * dyThrust;
         _angleMoving = (float)Math.atan2 (0-dy, dx);
         _speedMoving = (float)Math.sqrt(dx*dx + dy*dy);
         if (_speedMoving > engine.TopSpeed)
         {
            _speedMoving = engine.TopSpeed;
            dx = (float)Math.cos(_angleMoving) * _speedMoving;
            dy = (0-(float)Math.sin(_angleMoving)) * _speedMoving;
         }
      }

      if ((dx < engine.StopFactor) && (dx >= 0-engine.StopFactor))
         dx = 0;
      if ((dy < engine.StopFactor) && (dy >= 0-engine.StopFactor))
         dy = 0;
   }

   public void buildTables()
   {
      _facingAngles = new float[3][3];
      _facingAngles[0][0] = 3*PI/4;    _facingAngles[0][1] = PI/2;    _facingAngles[0][2] = PI/4;
      _facingAngles[1][0] = PI;        _facingAngles[1][1] = 0;       _facingAngles[1][2] = 0;
      _facingAngles[2][0] = 5*PI/4;    _facingAngles[2][1] = 3*PI/2;  _facingAngles[2][2] = 7*PI/8;
   }

   float _angleFacing;
   float _angleMoving;
   float _speedMoving;
   float _facingAngles[][];

   static final float PI = 3.14159265358979323846264338f;
}

