package com.randomsoftware.vncclient;

import danger.app.*;
import danger.ui.*;
import danger.util.*;
import java.util.*;

public class HandshakeState
{
   static final int WAITING_FOR_SERVER_VERSION = 0;
   static final int WAITING_FOR_SECURITY_TYPES = 1;
   static final int WAITING_FOR_SECURITY_DATA = 2;
   static final int WAITING_FOR_SECURITY_RESULT = 3;
   static final int STARTING_INITIALIZATION = 4;
   static final int WAITING_FOR_INITIALIZATION = 5;
   static final int ONLINE = 6;

   static public int toString (int state)
   {
      switch (state) {
         case WAITING_FOR_SERVER_VERSION:
            return Resources.IDS_CONNECTING_SERVER_VERSION;

         case WAITING_FOR_SECURITY_TYPES:
         case WAITING_FOR_SECURITY_DATA:
         case WAITING_FOR_SECURITY_RESULT:
            return Resources.IDS_CONNECTING_SECURITY;

         case STARTING_INITIALIZATION:
         case WAITING_FOR_INITIALIZATION:
         case ONLINE:
            return Resources.IDS_CONNECTING_CONFIG;

         default:
            return Resources.IDS_CONNECTING_OPENSOCKET;
      }
   }
}

