package com.randomsoftware.vncclient;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;

public class HelpContentDialog extends DialogWindow
{
   public HelpContentDialog()
   {
   }

   public void setText (String ss)
   {
      _text = ss;
   }

   public void show()
   {
      if (_box == null) {
         int xx = PADDING;
         int yy = PADDING + getTitleBarHeight();
         int cx = getWidth() - PADDING -cxSCROLLBAR - xx;
         int cy = getHeight() - PADDING - getTitleBarHeight() - yy;

         _bar = new Scrollbar();
         _box = new LinkTextBox();
         addChild(_box);
         addChild(_bar);

         _box.setText (danger.text.span.HTML.fromHTML(_text));
         _box.setPosition (xx, yy);
         _box.setSize (cx, cy);
         _box.setHasBorder (false);
         _box.attachScrollbar (_bar);
         _box.show();

         _bar.setPosition (xx + cx + PADDING/2, yy);
         _bar.setSize (cxSCROLLBAR, cy);
         _bar.show();

         setFocusedChild(_box);
      }

      super.show();
   }

   public boolean receiveEvent (Event ee)
   {
      return super.receiveEvent(ee);
   }

   public boolean reverseFocus()
   {
      if (getFocusedChild() == _box) {
         return false;
      } else {
         return super.reverseFocus();
      }
   }

   public boolean advanceFocus()
   {
      if (getFocusedChild() != _box) {
         return false;
      } else {
         return super.advanceFocus();
      }
   }

   LinkTextBox _box = null;
   Scrollbar _bar = null;
   String _text = null;

   static final int cxSCROLLBAR = 10;
   static final int PADDING = 10;
}

