package com.randomsoftware.vncclient;

import danger.app.*;
import danger.ui.*;
import danger.util.*;
import java.util.*;

public class HostListViewItem implements ActiveObject
{
   public HostListViewItem (HostSettings host)
   {
      friendlyName = host.friendlyName;
   }

   public HostSettings getHostSettings()
   {
      HostDatabase db = VncClient.getHostDatabase();
      int index = db.getHostIndexByName(friendlyName);
      if (index == HostDatabase.HOST_NOT_FOUND) {
         return null;
      } else {
         return db.getHostByIndex(index);
      }
   }

   public void update()
   {
   }

   public void addDelegate (ActiveObject.Delegate delegate)
   {
   }

   public void removeDelegate (ActiveObject.Delegate delegate)
   {
   }

   public void paint (Pen pp, int xx, int yy, int width, int height, boolean isFocused)
   {
      ResUtil ru = VncClient.getResUtil();
      SessionManager mgr = VncClient.getSessionManager();
      int state = mgr.getSessionState (friendlyName);

      String s1 = friendlyName;
      String s2 = ru.getString (SessionState.toString (state));
      Bitmap icon = ru.getBitmap (SessionState.toIcon (state));

      if (!isFocused) {
         int ich;
         if ((ich = s2.indexOf(';')) != -1) {
            s2 = s2.substring(0,ich);
         }
      }

      Font f1 = Compat.Font_findBoldSystemFont();
      int h1 = Compat.Font_getHeight(f1);
      int w1 = f1.getWidth(s1);

      int ySpace = (Compat.SCREEN_HEIGHT > 160) ? 0 : 1;
      int xSpace = (Compat.SCREEN_WIDTH > 240) ? 22 : 10;

      Font f2 = Compat.Font_findVariant(f1, f1.getSize()-3, Compat.Font_F_PLAIN);
      int h2 = Compat.Font_getHeight(f2);
      int w2 = f2.getWidth(s2);

      yy += (height - (h1 + ySpace + h2 - 2))/2;

      pp.setFont (f1);
      pp.drawText (xx + 8, yy + f1.getAscent(), s1);

      pp.setFont (f2);
      pp.drawText (xx + xSpace+16, yy + ySpace+h1 + f2.getAscent(), s2);

      pp.drawBitmap (xx + xSpace, yy + ySpace+h1 + f2.getAscent() - 8, icon);
   }

   String friendlyName;
}

