package com.randomsoftware.vncclient;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class ResUtil implements Resources
{
   public ResUtil (ResourceDatabase rdb)
   {
      _rdb = rdb;
   }

   public ResourceDatabase getDatabase()
   {
      return _rdb;
   }

   public String getString (int ids)
   {
      return _rdb.getString(ids);
   }

   public String getStringWithRepl (int ids, String repl)
   {
      String ss = getString(ids);

      int ich;
      if ((ich = ss.indexOf('%')) != -1)
         ss = ss.substring(0,ich) + repl + ss.substring(ich+1);

      return ss;
   }

   public Bitmap getBitmap (int idb)
   {
      return _rdb.getBitmap(idb);
   }

   public Bitmap getOpaqueBitmap (int idb)
   {
      return Bitmap.convertToScreenColorSpace (_rdb.getBitmap(idb));
   }

   public Bitmap getTransparentBitmap (int idb)
   {
      return getTransparentBitmap (idb, 0, 0);
   }

   public Bitmap getTransparentBitmap (int idb, int ix, int iy)
   {
      Bitmap bmp = Bitmap.convertToScreenColorSpace (_rdb.getBitmap(idb));
      int color = bmp.getPoint (ix, iy);
      int rr = (color >> 19) & 0x1F;
      int gg = (color >> 10) & 0x3F;
      int bb = (color >> 3) & 0x1F;
      bmp.setTransparentColor ((bb << 11) | (gg << 5) | rr);
      return bmp;
   }

   ResourceDatabase _rdb;
}

