package com.randomsoftware.vncclient;

import danger.app.*;
import danger.ui.*;
import danger.util.*;
import java.util.*;

public class SessionManager
{
   public SessionManager()
   {
      _sessions = new Vector();
   }

   public int getSessionState (String friendlyName)
   {
      Session ss = findSession(friendlyName);
      if (ss != null) {
         return ss.getState();
      } else {
         return SessionState.DISCONNECTED;
      }
   }

   public Session findSession (String friendlyName)
   {
      for (int ii = 0; ii < _sessions.size(); ++ii) {
         Session ss = (Session)(_sessions.elementAt(ii));
         if (friendlyName.equalsIgnoreCase(ss.getName())) {
            return ss;
         }
      }
      return null;
   }

   public void activateSession (HostSettings host)
   {
      Session ss = findSession (host.friendlyName);
      if (ss == null) {
         ss = new Session (host);
         _sessions.add(ss);
      } else {
         ss.retry();
      }
      VncClient.getHostListScreen().refresh();
      VncClient.app().showSession(ss);
   }

   public void closeSession (HostSettings host)
   {
      Session ss = findSession (host.friendlyName);
      if (ss != null) {
         _sessions.remove(ss);
         ss.destroy();

         if (VncClient.app().getVisibleSession() == ss) {
            VncClient.app().showSession(null);
         }

         VncClient.getHostListScreen().refresh();
      }
   }

   Vector _sessions;
}

