package com.randomsoftware.vncclient;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;

public class SessionStateDialog extends DialogWindow
{
   public SessionStateDialog()
   {
      _timer = new danger.app.Timer (100, true, this);
      _timer.start();
   }

   protected void updateProgressBar()
   {
      Control ctl = getControlWithID(Resources.IDC_STATE_PROGRESS);
      if (ctl instanceof ProgressBar) {
         ((ProgressBar)ctl).advanceState();
      }
   }

   protected void forwardEvent (int type)
   {
      RemoteScreen screen;
      if ((screen = VncClient.getRemoteScreen()) != null) {
         if (type == ResourceEvents.EVENT_STATE_RETRY) {
            readPassword();
         }
         screen.sendEvent (new Event (type));
      }
   }

   protected void readPassword()
   {
      String password = ((TextField)getControlWithID(Resources.IDC_STATE_PASSWORD)).toString();
      CheckBox ctl = (CheckBox)getControlWithID(Resources.IDC_STATE_REMEMBER);
      HostSettings host = VncClient.getVisibleSession().getHostSettings();

      if (ctl.getValue() == 0) {
         host.tempPassword = new String(password);
      } else {
         host.tempPassword = null;
         host.password = new String(password);
         VncClient.getHostDatabase().saveHost (host);
         VncClient.getVisibleSession().updateHostSettings (host);
      }
   }

   public boolean receiveEvent (Event ee)
   {
      switch (Compat.Event_getType(ee))
      {
         case EventType.EVENT_TIMER:
            updateProgressBar();
            break;

         case ResourceEvents.EVENT_STATE_HIDE:
         case ResourceEvents.EVENT_STATE_GIVEUP:
         case ResourceEvents.EVENT_STATE_RETRY:
            forwardEvent (Compat.Event_getType(ee));
            break;
      }
      return super.receiveEvent(ee);
   }

   public final boolean eventWidgetUp (int widget, Event ee)
   {
      switch (widget)
      {
         case Event.DEVICE_BUTTON_CANCEL:
            forwardEvent (ResourceEvents.EVENT_STATE_GIVEUP);
            break;

         case Event.DEVICE_BUTTON_BACK:
            if (isPasswordDialog()) {
               forwardEvent (ResourceEvents.EVENT_STATE_RETRY);
            } else {
               forwardEvent (ResourceEvents.EVENT_STATE_HIDE);
            }
            break;
      }

      return super.eventWidgetUp(widget, ee);
   }

   protected boolean isPasswordDialog()
   {
      Control ctl = getControlWithID(Resources.IDC_STATE_PASSWORD);
      return (ctl instanceof TextField);
   }

   danger.app.Timer _timer;
}

