package com.randomsoftware.vncclient;

import danger.ui.*;
import danger.app.*;
import danger.util.*;

public class VncClient extends Application
{
   public VncClient() 
   {
      _globalApplication = this;
      _remoteScreen = null;
      _ru = new ResUtil (getResources());
      _hostDatabase = new HostDatabase();
      _cellManager = new CellManager();
      _sessionManager = new SessionManager();
      _hostListScreen = (HostListScreen)getResources().getScreen(Resources.ID_SCREEN_HOST_LIST);
   }

   public void suspend()
   {
      _cellManager.releaseMemory();
      DataStream.releaseMemory();
   }

   public void resume()
   {
      if (_remoteScreen != null) {
         _remoteScreen.show();
      } else {
         _hostListScreen.show();
      }
   }

   public void showSession (Session ss)
   {
      if (ss == null) {
         if (_remoteScreen != null) {
            _hostListScreen.show();
            _remoteScreen.hide();
            _remoteScreen = null;
         }
      } else if (_remoteScreen == null) {
         _remoteScreen = (RemoteScreen)getResources().getScreen(Resources.ID_SCREEN_MAIN);
         _remoteScreen.init(ss);
         _remoteScreen.show();
         _hostListScreen.hide();
      } else if (_remoteScreen.getSession() != ss) {
         _remoteScreen.hide();
         _remoteScreen = (RemoteScreen)getResources().getScreen(Resources.ID_SCREEN_MAIN);
         _remoteScreen.init(ss);
         _remoteScreen.show();
      }
   }

   public static Session getVisibleSession()
   {
      return (app()._remoteScreen == null) ? null : app()._remoteScreen.getSession();
   }

   public static VncClient app()
   {
      return _globalApplication;
   }

   public static HostDatabase getHostDatabase()
   {
      return _globalApplication._hostDatabase;
   }

   public static HostListScreen getHostListScreen()
   {
      return _globalApplication._hostListScreen;
   }

   public static RemoteScreen getRemoteScreen()
   {
      return _globalApplication._remoteScreen;
   }

   public static SessionManager getSessionManager()
   {
      return _globalApplication._sessionManager;
   }

   public static CellManager getCellManager()
   {
      return _globalApplication._cellManager;
   }

   public static ResUtil getResUtil()
   {
      return _globalApplication._ru;
   }

   public boolean receiveEvent (Event ee)
   {
      return super.receiveEvent(ee);
   }


   protected static VncClient _globalApplication = null;
   protected ResUtil _ru;
   protected HostDatabase _hostDatabase;
   protected HostListScreen _hostListScreen;
   protected SessionManager _sessionManager;
   protected RemoteScreen _remoteScreen;
   protected CellManager _cellManager;
}

