package com.randomsoftware.common.animation;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;

public class AnimSequencer
{
   public AnimSequencer()
   {
      _events = new Vector();
      _highframe = 0;
   }

   public boolean isEmpty()
   {
      return _events.isEmpty();
   }

   public void queueEvent (AnimSequencerEvent event)
   {
      _events.addElement (event);
      if (event._framenumber > _highframe)
         _highframe = event._framenumber;
   }

   public void removeSprite (AnimSprite object)
   {
      for (int ii = 0; ii < _events.size(); )
      {
         if (((AnimSequencerEvent)_events.elementAt(ii))._object == object)
            _events.removeElementAt(ii);
         else
            ++ii;
      }
      if (_events.isEmpty())
         _highframe = 0;
   }

   public void advanceFrame (int newframe)
   {
      for (int ii = 0; ii < _events.size(); )
      {
         AnimSequencerEvent ase = (AnimSequencerEvent)_events.elementAt(ii);

         if (ase._framenumber > newframe)
         {
            ++ii;
         }
         else
         {
            _events.removeElementAt(ii);
            ase.trigger();
         }
      }
   }

   public int getFinalFrame()
   {
      return _highframe;
   }

   Vector _events;
   int _highframe;
}

