package com.randomsoftware.common.animation;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;

public class AnimSprite extends Listener
{
   public int depth = 0;
   public AnimSprite next = null;
   public AnimSprite prev = null;
   public Rect pos = new Rect();
   public Bitmap bmp = null;

   public AnimSprite (AnimWindow win, int dd)
   {
      depth = dd;
      _win = win;
      _win._sprites.add (this);
      _active = true;
      touch();
   }

   public AnimSprite (AnimWindow win, int dd, Rect rr, Bitmap bmpAutodraw)
   {
      depth = dd;
      pos = new Rect(rr);
      bmp = bmpAutodraw;
      _win = win;
      _win._sprites.add (this);
      _active = true;
      touch();
   }

   public void destroy()
   {
      if (_active)
      {
         touch();
         _active = false;
         _win.removeSprite (this);
         _win._sprites.remove (this);
      }
   }

   public void finalize()
   {
      destroy();
   }

   public void setDepth (int dd)
   {
      if (depth != dd)
      {
         _win._sprites.remove (this);
         depth = dd;
         _win._sprites.add (this);
         touch();
      }
   }

   public void setRect (Rect rr)
   {
      touch();
      pos.left = rr.left;
      pos.top = rr.top;
      pos.right = rr.right;
      pos.bottom = rr.bottom;
      touch();
   }

   public void touch ()
   {
      _win.touch (pos);
   }

   public void update ()
   {
   }

   public void paint (Pen pp)
   {
      if (bmp != null)
         pp.drawBitmap (0, 0, bmp);
   }

   public boolean isOnScreen ()
   {
      return ((pos.right >= 0) && (pos.left < 240) && (pos.bottom >= 0) && (pos.top < 160));
   }


   protected AnimWindow _win;
   protected boolean _active;
}

