package com.randomsoftware.common.animation;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;

public class AnimSpriteList
{
   public void add (AnimSprite obj)
   {
      Integer dd = new Integer (obj.depth);
      AnimSprite next = (AnimSprite)_depths.get(dd);

      if (next == null)
      {
         Integer dNextHighest = dd;

         Enumeration ee = _depths.keys();
         while (ee.hasMoreElements())
         {
            Integer found = (Integer)ee.nextElement();
            if (found.intValue() < dd.intValue())
               continue;
            if ((dNextHighest.intValue() != dd.intValue()) && (found.intValue() > dNextHighest.intValue()))
               continue;
            dNextHighest = found;
         }

         if (dNextHighest != null)
         {
            next = (AnimSprite)_depths.get(dNextHighest);
         }
      }

      insertIntoChain (obj, next);
      _depths.put (dd, obj);
   }

   public void remove (AnimSprite obj)
   {
      Integer dd = new Integer (obj.depth);
      AnimSprite first = (AnimSprite)_depths.get(dd);

      AnimSprite other = obj.next;
      if ((other == null) || (other.depth != dd.intValue()))
      {
         other = obj.prev;
         if ((other != null) && (other.depth != dd.intValue()))
            other = null;
      }

      removeFromChain (obj);

      if (first == obj)
      {
         if (other == null)
            _depths.remove (dd);
         else
            _depths.put (dd, other);
      }
   }

   public void removeAll()
   {
      while (_head != null)
         remove (_head);
   }

   public AnimSprite getClosest()
   {
      return _head;
   }

   public AnimSprite getFurthest()
   {
      return _tail;
   }

   public AnimSprite getCloser (AnimSprite obj)
   {
      return (obj == null) ? null : obj.prev;
   }

   public AnimSprite getFurther (AnimSprite obj)
   {
      return (obj == null) ? null : obj.next;
   }

   void insertIntoChain (AnimSprite newobj, AnimSprite nextobj)
   {
      if (nextobj == null)
      {
         newobj.prev = _tail;
         newobj.next = null;
         _tail = newobj;
      }
      else
      {
         newobj.next = nextobj;
         newobj.prev = nextobj.prev;
         nextobj.prev = newobj;
      }
      if (newobj.prev == null)
         _head = newobj;
      else
         newobj.prev.next = newobj;
   }

   void removeFromChain (AnimSprite obj)
   {
      if (obj.next == null)
         _tail = obj.prev;
      else
         obj.next.prev = obj.prev;

      if (obj.prev == null)
         _head = obj.next;
      else
         obj.prev.next = obj.next;
   }

   Hashtable _depths = new Hashtable();
   AnimSprite _head = null;
   AnimSprite _tail = null;
}

