package com.randomsoftware.common.webscore;
import com.randomsoftware.common.xmllib.*;

import java.util.*;
import danger.app.*;
import danger.net.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class GlobalScoreList extends ScoreList
{
   public GlobalScoreList (int maxCount)
   {
      _maxCount = maxCount;
   }

   public void update (String raw)
   {
      try {

         // <response action=listgames>
         //    <score playername=Tom rank=5 date="Jan 11, 2006">10000</score>
         // </response>

         XmlTag tag = XmlParser.read(raw).getTag("response");
         if ((tag == null) || (!tag.getAttribute("action").equals("listscores")))
            throw new XmlFormatException ("received invalid response from webscore server");

         clear();

         for (int ii = 0; ii < tag.children.size(); ++ii)
         {
            Object o = tag.children.elementAt(ii);
            if ((o instanceof XmlTag) && (((XmlTag)o).text.equals("score")))
            {
               XmlTag score = (XmlTag)o;
               try {
                  ScoreRecord sr = new ScoreRecord();
                  sr.name = score.getAttribute("playername");
                  sr.date = score.getAttribute("date");
                  sr.rank = Integer.valueOf(score.getAttribute("rank")).intValue();
                  sr.score = Integer.valueOf(score.getText()).intValue();
                  _scores.insertElementAt (sr, size());

                  if (size() == _maxCount)
                     break;
               } catch (NumberFormatException e) {
               }
            }
         }

      } catch (XmlFormatException e) {
         // Oh well.
      }
   }

   int _maxCount;
}

