package com.randomsoftware.common.webscore;

import java.util.*;
import danger.app.*;
import danger.net.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class ScoreList
{
   public ScoreList()
   {
      _scores = new Vector();
   }

   public int size()
   {
      return _scores.size();
   }

   public ScoreRecord elementAt (int ii)
   {
      return (ScoreRecord)(_scores.elementAt(ii));
   }

   public void clear()
   {
      // 2.0 didn't have a vector::clear() method
      while (_scores.size() != 0)
         _scores.removeElementAt (_scores.size()-1);
   }

   public boolean insertRecord (ScoreRecord srNew, int maxCount)
   {
      int insertIndex = -1;

      for (int ii = 0; ii < size(); ++ii)
      {
         if (srNew.score > elementAt(ii).score)
         {
            insertIndex = ii;
            _scores.insertElementAt (srNew, insertIndex);
            break;
         }
      }

      if ((insertIndex == -1) && (size() < maxCount))
      {
         insertIndex = size();
         _scores.insertElementAt (srNew, insertIndex);
      }

      while (size() > maxCount)
      {
         _scores.removeElementAt (size()-1);
      }

      return (insertIndex < maxCount);
   }

   public String toString()
   {
      String ss = "HIGH SCORES:\n";
      for (int ii = 0; ii < size(); ++ii)
      {
         ScoreRecord sr = elementAt(ii);
         ss += "   "+sr.rank+": "+sr.name+" - "+sr.score+" ("+sr.date+")\n";
      }
      return ss;
   }

   Vector _scores;
}

