package com.randomsoftware.common.webscore;
import com.randomsoftware.common.xmllib.*;

import java.util.*;
import danger.app.*;
import danger.net.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class ScoreRecord
{
   public String name;
   public String date;
   public int rank;
   public int score;

   public ScoreRecord()
   {
      name = null;
      date = null;
      rank = 0;
      score = 0;
   }

   static final String monthNames[] = {
      "Jan", "Feb", "Mar", "Apr", "May", "Jun",
      "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
   };

   static String makeDoubleDigit (int val)
   {
      if (val < 10)
         return "0"+val;
      else
         return ""+val;
   }

   static String makeTwelve (int val)
   {
      val %= 12;
      return "" + ((val == 0) ? 12 : val);
   }

   public ScoreRecord (String ss, int val)
   {
      Calendar now = Calendar.getInstance();
      name = ss;

      date = now.get(Calendar.DAY_OF_MONTH) +
                  "-" +
             monthNames[now.get(Calendar.MONTH)] +
                  "-" +
             now.get(Calendar.YEAR) +
                  "  " +
             makeTwelve(now.get(Calendar.HOUR)) +
                  ":" +
             makeDoubleDigit(now.get(Calendar.MINUTE)) +
             ((now.get(Calendar.AM_PM) == Calendar.AM) ? "am" : "pm");

      rank = 0;
      score = val;
   }

   public ScoreRecord (byte[] data)
   {
      DataRecord rec = new DataRecord (data, 4);
      name = rec.getString (0, 0);
      date = rec.getString (1, 0);
      rank = rec.getInt (2, 0);
      score = rec.getInt (3, 0);
   }

   public byte[] toData()
   {
      DataRecord rec = new DataRecord (4);
      rec.putString (0, 0, name);
      rec.putString (1, 0, date);
      rec.putInt (2, 0, rank);
      rec.putInt (3, 0, score);
      return rec.mData;
   }
}

