package com.randomsoftware.common.meshlib;

import java.util.*;
import java.io.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class FaceData
{
   int iTexture;
   int iVertex1;
   int iVertex2;
   int iVertex3;
   boolean isDoubleSided;

   FaceData (DataInputStream ds, boolean haveTextures, TextureData[] textures) throws IOException
   {
      int vv = ds.readInt();
      iVertex1 = (vv >> 24) & 0xFF;
      iVertex2 = (vv >> 16) & 0xFF;
      iVertex3 =  (vv >> 8) & 0xFF;
      iTexture =         vv & 0x7F;
      isDoubleSided =  ((vv & MeshResource.JMC_FACEFLAG_DOUBLESIDED) != 0);

      if (haveTextures)
      {
         ds.readInt();  // discard u1,v1
         ds.readInt();  // discard u2,v2
         ds.readInt();  // discard u3,v3
      }
   }
}

