package com.randomsoftware.common.meshlib;

import java.util.*;
import java.io.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;
import danger.system.*;

public class TriangleClipper
{
   static void fillTriangle (Pen pp, int[] ax, int[] ay)
   {
      if (!canSkip (ax, ay))
         pp.fillPoly (ax, ay);
   }

   static boolean canSkip (int[] ax, int[] ay)
   {
      if (ax[0] < LEFT && ax[1] < LEFT && ax[2] < LEFT)
         return true;
      if (ay[0] < TOP && ay[1] < TOP && ay[2] < TOP)
         return true;
      if (ax[0] > RIGHT && ax[1] > RIGHT && ax[2] > RIGHT)
         return true;
      if (ay[0] > BOTTOM && ay[1] > BOTTOM && ay[2] > BOTTOM)
         return true;
      return false;
   }

   static final int LEFT = 0;
   static final int RIGHT = 240;
   static final int TOP = 0;
   static final int BOTTOM = 160;
}

