package com.randomsoftware.common.meshlib;

import java.util.*;
import java.io.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class ImageList
{
   public ImageList()
   {
      _nameToIndex = new java.util.HashMap();
      _indexToMapping = null;
      _countMapped = 0;
   }

   public void add (String name, ImageMapping imageMapping)
   {
      resizeMappings();

      int index = _countMapped++;
      _nameToIndex.put (name, new Integer (index));
      _indexToMapping[index] = imageMapping;
   }

   public ImageMapping getImageMapping (String name)
   {
      Object oo = _nameToIndex.get(name);
      if (oo == null)
         return null;
      else
         return _indexToMapping[ ((Integer)oo).intValue() ];
   }

   public void loadImages (ResourceDatabase rdb)
   {
      for (int ii = 0; ii < _countMapped; ++ii)
         _indexToMapping[ii].load (rdb);
   }

   public void unloadImages()
   {
      for (int ii = 0; ii < _countMapped; ++ii)
         _indexToMapping[ii].unload();
   }

   void resizeMappings()
   {
      if ((_indexToMapping == null) || (_countMapped + 1 > _indexToMapping.length))
      {
         int newsize = _countMapped + 16;
         ImageMapping[] newList = new ImageMapping[ newsize ];

         if (_indexToMapping != null)
         {
            for (int ii = 0; ii < _countMapped; ++ii)
               newList[ii] = _indexToMapping[ii];
         }

         _indexToMapping = newList;
      }
   }

   java.util.HashMap _nameToIndex;
   ImageMapping[] _indexToMapping;
   int _countMapped;
}

