package com.randomsoftware.common.meshlib;

import java.util.*;
import java.io.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class TextureData
{
   public int r;
   public int g;
   public int b;
   public ImageMapping imageMapping;
   Texture texture;

   public TextureData (int rr, int gg, int bb)
   {
      r = rr;
      g = gg;
      b = bb;
      imageMapping = null;
      texture = null;
   }

   TextureData (DataInputStream ds, boolean haveTextures, String[] imageNames, ImageList imageList) throws IOException
   {
      int vv = ds.readInt();
      r = (vv >> 24) & 0xFF;
      g = (vv >> 16) & 0xFF;
      b = (vv >>  8) & 0xFF;
      texture = null;
      imageMapping = null;

      if (haveTextures)
      {
         int imageIndexPlus1 = vv & 0xFF;
         if (imageIndexPlus1 != 0)
         {
            if ((imageNames == null) || (imageIndexPlus1 > imageNames.length))
            {
               DEBUG.p ("mesh references illegal image index");
               throw new IOException();
            }
            else if (imageIndexPlus1 != 0)
            {
               String ss = imageNames[imageIndexPlus1-1];
               imageMapping = imageList.getImageMapping(ss);
               if (imageMapping == null)
               {
                  DEBUG.p ("mesh references unrecognized texture "+ss+"; did you supply a mapping for it?");
                  // Non-fatal; we'll just draw this thing solid-colored
               }
            }
         }
      }
   }
}

