package com.randomsoftware.common.meshlib;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Actor extends Entity
{
   public Mesh firstMesh = null;
   public Mesh lastMesh = null;

   public Trigger firstTrigger = null;
   public Trigger lastTrigger = null;

   public Actor nextActorInScene;
   public Actor prevActorInScene;

   public Actor (Scene sc)
   {
      _scene = sc;

      // Insert(scene.actors)
      if ((prevActorInScene = _scene.lastActor) != null)
         prevActorInScene.nextActorInScene = this;
      else
         _scene.firstActor = this;
      nextActorInScene = null;
      _scene.lastActor = this;
   }

   public void destroy()
   {
      // Remove(scene.actors)
      if (nextActorInScene != null)
         nextActorInScene.prevActorInScene = prevActorInScene;
      else
         _scene.lastActor = prevActorInScene;
      if (prevActorInScene != null)
         prevActorInScene.nextActorInScene = nextActorInScene;
      else
         _scene.firstActor = nextActorInScene;
   }

   public void invalidate()
   {
      if (!isChanged)
      {
         super.invalidate();

         for (Mesh mm = firstMesh; mm != null; mm = mm.nextMeshInActor)
            mm.invalidate();

         for (Trigger tt = firstTrigger; tt != null; tt = tt.nextTriggerInActor)
            tt.invalidate();
      }
   }

   public void recalculate()
   {
      for (Mesh mm = firstMesh; mm != null; mm = mm.nextMeshInActor)
         mm._mxMeshToWorld.makeMultiply (this, mm);

      isChanged = false;
   }

   public void update()
   {
   }

   Scene _scene;
}

