package com.randomsoftware.common.meshlib;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class BasicFace extends FaceSortable
{
   public Vertex vertex1;
   public Vertex vertex2;
   public Vertex vertex3;
   public boolean isDoubleSided;
   public Texture texture;

   public Face nextFaceInMesh;
   public Face prevFaceInMesh;

   BasicFace (Scene scene, Mesh mesh, TextureData[] td, VertexData[] vd, FaceData fd)
   {
      vertex1 = vd[ fd.iVertex1 ].vertex;
      vertex2 = vd[ fd.iVertex2 ].vertex;
      vertex3 = vd[ fd.iVertex3 ].vertex;
      texture = td[ fd.iTexture ].texture;
      isDoubleSided = fd.isDoubleSided;
   }

   BasicFace (Scene scene, Mesh mesh, Vertex v1, Vertex v2, Vertex v3, Texture tx)
   {
      vertex1 = v1;
      vertex2 = v2;
      vertex3 = v3;
      texture = tx;
      isDoubleSided = false;
   }

   public void destroy()
   {
      clearLights();
      _firstFaceLight = _lastFaceLight = null;
   }

   public void clearLights()
   {
      while (_firstFaceLight != null)
      {
         _firstFaceLight.removeFromLight();
         _scene._faceLightFactory.release(_firstFaceLight);
         _firstFaceLight = _firstFaceLight.nextFaceLightInFace;
      }

      _firstFaceLight = null;
      _lastFaceLight = null;
   }

   public void paintSolid (Pen pp, int[] ax, int[] ay)
   {
      TriangleClipper.fillTriangle (pp, ax, ay);
   }

   FaceLight _firstFaceLight = null;
   FaceLight _lastFaceLight = null;

   Scene _scene;
   Mesh _mesh;
   boolean _fWillRender = true;

   public Triplet _vNormalInWorld;
   public Triplet _vNormalInCamera;
}

