package com.randomsoftware.common.meshlib;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class Entity extends FixedMatrix
{
   public boolean isChanged;

   public Entity()
   {
      isChanged = true;
   }

   public Entity (Entity src)
   {
      super(src);
      isChanged = true;
   }

   public void makeZero()
   {
      super.makeZero();
      invalidate();
   }

   public void makeIdentity()
   {
      super.makeIdentity();
      invalidate();
   }

   public void addRotationX (long ang)
   {
      super.addRotationX(ang);
      invalidate();
   }

   public void addRotationY (long ang)
   {
      super.addRotationY(ang);
      invalidate();
   }

   public void addRotationZ (long ang)
   {
      super.addRotationZ(ang);
      invalidate();
   }

   public void addRotation (Rotation rot)
   {
      super.addRotation(rot);
      invalidate();
   }

   public void addRotation (Triplet axis, long ang)
   {
      super.addRotation(axis, ang);
      invalidate();
   }

   public void addTranslationX (long dist)
   {
      super.addTranslationX(dist);
      invalidate();
   }

   public void addTranslationY (long dist)
   {
      super.addTranslationY(dist);
      invalidate();
   }

   public void addTranslationZ (long dist)
   {
      super.addTranslationZ(dist);
      invalidate();
   }

   public void addTranslation (long dx, long dy, long dz)
   {
      super.addTranslation(dx, dy, dz);
      invalidate();
   }

   public void addTranslation (Triplet tt)
   {
      super.addTranslation(tt);
      invalidate();
   }

   public void setLocation (long xx, long yy, long zz)
   {
      super.setLocation (xx, yy, zz);
      invalidate();
   }

   public void scale (long dx, long dy, long dz)
   {
      super.scale(dx, dy, dz);
      invalidate();
   }

   public void multiplyBy (FixedMatrix mult)
   {
      super.multiplyBy(mult);
      invalidate();
   }

   public void invalidate()
   {
      isChanged = true;
   }
}

