package com.randomsoftware.common.terrain;
import com.randomsoftware.common.animation.*;
import com.randomsoftware.common.meshlib.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class GroundFace extends Face
{
   public GroundFace (GroundMeshGrid grid, GroundVertex gv1, int u1, int v1, GroundVertex gv2, int u2, int v2, GroundVertex gv3, int u3, int v3, Texture tx)
   {
      super (grid._gm._scene, grid._gm, gv1, gv2, gv3, tx);
      setTextureCoords (u1, v1, u2, v2, u3, v3);
      _grid = grid;
      _nextInFreeList = null;
   }

   void assign (GroundVertex gv1, int u1, int v1, GroundVertex gv2, int u2, int v2, GroundVertex gv3, int u3, int v3, Texture tx)
   {
      vertex1 = gv1;
      vertex2 = gv2;
      vertex3 = gv3;
      texture = tx;
      setTextureCoords (u1, v1, u2, v2, u3, v3);
   }

   void connect()
   {
      _grid._gm.connectFace(this);
   }

   void disconnect()
   {
      _grid._gm.disconnectFace(this);
   }

   GroundMeshGrid _grid;
   GroundFace _nextInFreeList;
}

