package com.randomsoftware.common.terrain;
import com.randomsoftware.common.animation.*;
import com.randomsoftware.common.meshlib.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class GroundVertex extends Vertex
{
   public GroundVertex (GroundMeshGrid grid, long x, long y, long z)
   {
      super (x, y, z);
      _grid = grid;
      _nextInFreeList = null;
      _refcount = 0;
   }

   void assign (long x, long y, long z)
   {
      dx = x;
      dy = y;
      dz = z;
   }

   void connect()
   {
      if ((++_refcount) == 1)
         _grid._gm.connectVertex(this);
   }

   static final int STILL_IN_USE = 1;
   static final int NO_LONGER_NEEDED = 0;
   int disconnect()
   {
      if ((--_refcount) > 0)
         return STILL_IN_USE;
      _grid._gm.disconnectVertex(this);
      return NO_LONGER_NEEDED;
   }

   GroundMeshGrid _grid;
   GroundVertex _nextInFreeList;
   int _refcount;
   int _ix;
   int _iz;
}

