package com.randomsoftware.common.terrain;
import com.randomsoftware.common.animation.*;
import com.randomsoftware.common.meshlib.*;

import java.util.*;
import danger.app.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class GroundViewer
{
   public GroundViewer (HeightMap heightMap, long xx, long zz, long oo)
   {
      _heightMap = heightMap;
      recalculate(xx, zz, oo);
   }

   public void update (long xx, long zz, long oo)
   {
      if ((xx != target.dx) || (zz != target.dz) || (oo != orientation))
      {
         recalculate (xx, zz, oo);
      }
   }

   void recalculate (long xx, long zz, long oo)
   {
      orientation = oo;

      target.dx = xx;
      target.dz = zz;
      target.dy = _heightMap.getTerrainHeight (target.dx, target.dz) + targetHeight;

      source.dx = target.dx - FixedMath.multiply (range, FixedMath.cosine(orientation));
      source.dz = target.dz - FixedMath.multiply (range, FixedMath.sine(orientation));
      source.dy = _heightMap.getTerrainHeight (source.dx, source.dz);
      source.dy += sourceHeight;
   }

   public Triplet target = new Triplet();
   public Triplet source = new Triplet();
   public long orientation;
   public long range = 5 << FixedMath.SHIFT;
   public long targetHeight = (long)(FixedMath.PREC*4.5);
   public long sourceHeight = (long)(FixedMath.PREC*5);
   public long fov = FixedMath.HEXIAN_45;

   HeightMap _heightMap;
}

