package com.randomsoftware.common.webscore;

import java.util.*;
import danger.app.*;
import danger.net.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class ScoreRecord
{
   // persistent data
   public String date;
   public int score;

   // calculated data
   public int recnum;

   public ScoreRecord()
   {
      date = null;
      score = 0;
   }

   static final String monthNames[] = {
      "Jan", "Feb", "Mar", "Apr", "May", "Jun",
      "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
   };

   static String makeDoubleDigit (int val)
   {
      if (val < 10)
         return "0"+val;
      else
         return ""+val;
   }

   static String makeTwelve (int val)
   {
      val %= 12;
      return "" + ((val == 0) ? 12 : val);
   }

   public ScoreRecord (int val)
   {
      Calendar now = Calendar.getInstance();

      date = now.get(Calendar.DAY_OF_MONTH) +
                  "-" +
             monthNames[now.get(Calendar.MONTH)] +
                  "-" +
             now.get(Calendar.YEAR) +
                  "  " +
             makeTwelve(now.get(Calendar.HOUR)) +
                  ":" +
             makeDoubleDigit(now.get(Calendar.MINUTE)) +
             ((now.get(Calendar.AM_PM) == Calendar.AM) ? "am" : "pm");

      score = val;
   }

   public ScoreRecord (int rn, byte[] data)
   {
      DataRecord rec = new DataRecord (data, 4);
      recnum = rn;
      date = rec.getString (0, 0);
      score = rec.getInt (1, 0);
   }

   public byte[] toData()
   {
      DataRecord rec = new DataRecord (4);
      rec.putString (0, 0, date);
      rec.putInt (1, 0, score);
      return rec.mData;
   }
}

