package com.randomsoftware.common.webscore;

import java.util.*;
import danger.app.*;
import danger.net.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

public class WebScore
{
   public WebScore (String game)
   {
      _game = game;
      _localScores = new LocalScoreList (MAX_LOCAL_SCORES);
   }

   public LocalScoreList getLocalScores()
   {
      return _localScores;
   }

   public void postLocalScore (int score)
   {
      _localScores.add (new ScoreRecord (score));
   }

   static char hexdigit (int val)
   {
      if (val < 10)
         return (char)(val + (int)'0');
      else if (val < 16)
         return (char)(val-10 + (int)'A');
      else
         return '-';
   }

   String encodeString (String in)
   {
      byte[] bytes = in.getBytes();

      StringBuffer out = new StringBuffer();
      for (int ii = 0; ii < bytes.length; ++ii)
      {
         if ( ((bytes[ii] >= (byte)'a') && (bytes[ii] <= (byte)'z')) ||
              ((bytes[ii] >= (byte)'A') && (bytes[ii] <= (byte)'Z')) ||
              ((bytes[ii] >= (byte)'0') && (bytes[ii] <= (byte)'9')) )
         {
            out.append ((char)bytes[ii]);
         }
         else
         {
            out.append ('%');
            out.append (hexdigit(bytes[ii]/16));
            out.append (hexdigit(bytes[ii]%16));
         }
      }

      return out.toString();
   }

   String getSafeString (String in)
   {
      byte[] bytes = in.getBytes();

      StringBuffer out = new StringBuffer();
      for (int ii = 0; ii < bytes.length; ++ii)
      {
         if ((bytes[ii] != '"') && (bytes[ii] != '<') && (bytes[ii] != '>') && (bytes[ii] != '%'))
         {
            out.append ((char)bytes[ii]);
         }
      }

      return out.toString();
   }

   String _game;
   LocalScoreList _localScores;

   static final int MAX_LOCAL_SCORES = 20;
}

