package com.randomsoftware.common.xmllib;

import java.util.*;
import danger.app.*;
import danger.net.*;
import danger.ui.*;
import danger.util.*;
import danger.audio.*;

class XmlParsePoint
{
   public int ibPos;
   public XmlParsePoint (int ib) { ibPos = ib; }
};

public class XmlTextStream
{
   public XmlTextStream (String input)
   {
      _cbInput = input.length();
      _abInput = new char [ _cbInput ];
      input.getChars (0, _cbInput, _abInput, 0);
      _ibPos = 0;
      _stack = new Stack();
   }

   public int getPos()
   {
      return _ibPos;
   }

   public void setPos (int ibPos)
   {
      _ibPos = ibPos;
      if (_ibPos < 0)
         _ibPos = 0;
      else if (_ibPos > _cbInput)
         _ibPos = _cbInput;
   }

   public void pushPos()
   {
      _stack.push (new XmlParsePoint (_ibPos));
   }

   public void popPos()
   {
      if (!_stack.empty())
         setPos (((XmlParsePoint)_stack.pop()).ibPos);
   }

   public void rewind()
   {
      _ibPos = 0;
   }

   public void advance()
   {
      advance(1);
   }

   public void advance (int cb)
   {
      if ((_ibPos += cb) > _cbInput)
         _ibPos = _cbInput;
   }

   public void reverse (int cb)
   {
      if ((_ibPos -= cb) < 0)
         _ibPos = 0;
   }

   public char peek()
   {
      return (_ibPos < _cbInput) ? _abInput[_ibPos] : 0;
   }

   public char peekAt (int plus)
   {
      return (_ibPos+plus < _cbInput) ? _abInput[_ibPos+plus] : 0;
   }

   public char read()
   {
      return (_ibPos < _cbInput) ? _abInput[_ibPos++] : 0;
   }

   public boolean matches (String ss)
   {
      byte[] target = ss.getBytes();
      for (int ii = 0; ii < target.length; ++ii)
      {
         if (peekAt(ii) != (char)target[ii])
            return false;
      }
      return true;
   }


   public boolean iseol()
   {
      return iseol(peek());
   }

   public boolean iswhite()
   {
      return iswhite(peek());
   }

   public boolean iswhiteeol()
   {
      return iswhiteeol(peek());
   }

   public static boolean iseol (char c)
   {
      return (c == '\r' || c == '\n');
   }

   public static boolean iswhite (char c)
   {
      return (c == ' ' || c == '\t');
   }

   public static boolean iswhiteeol (char c)
   {
      return iswhite(c) || iseol(c);
   }


   char[] _abInput;
   int _cbInput;
   int _ibStart;
   int _ibPos;
   Stack _stack;
}

